; DEFF, DEFI, DEFB : default field, index, buffer
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
        include dev8_qdos_sms
*
; set default buffer to work with
; parameters
p.bid   equ     $0      ; buffer id (long word)
; errors
; itnf  buffer id invalid
; ijob  we can't use this buffer for this job
cod_DEFB xsub
        regsave d1/d2/a0/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.bid(a5),d0    ; buffer id if passed
        move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        moveq   #sms.info,d0    ; get system info
        trap    #do.sms2        ; current jobid in d1
        moveq   #err.ijob,d0    ; assume worst case
        cmp.l   b_jobid(a4),d1  ; compare it with the user of this buffer
        bne.s   codend          ; no, not for this one

        move.l  a4,d0
        xjsr    setbuff         ; set default buffer
        moveq   #0,d0           ; everything ok
codend
        subend
*
; set default field
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; default field (uword)
; errors
; itnf  buffer id invalid
cod_DEFF xsub
        regsave a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   dfbuff          ; yes -> ..
        xjsr    getbuff         ; get default buffer
dfbuff  move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   dfend           ; if not -> error

        move.b  p.fld+3(a5),b_dfield(a4); fill in default field
        moveq   #0,d0           ; all ok
dfend
        subend
*
; set default index
; parameters
;p.id    equ     $4      ; bufferid (long word, optional)
p.iid   equ     $8      ; indexid (long word) (if 0 -> no index)
; errors
; itnf  bufferid or indexid invalid
cod_DEFI xsub
        regsave d1/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   dibuff          ; yes -> ..
        xjsr    getbuff         ; get default buffer
dibuff  move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   diend           ; if not -> error

        move.l  p.iid(a5),d0    ; index id if passed
        beq.s   diok            ; no problem if no index
        xjsr    testiid         ; and test if it is valid
        bne.s   diend           ; if not -> error

diok    move.l  d1,b_dindex(a4) ; fill in default index
        moveq   #0,d0           ; no problems
diend
        subend
;
        end
