; routine to clear a field
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; clear a field
; if ALL is set, then the record is implemented first (if the field exists) !!
;              it is not known which record will end up in the buffer
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; id of field to rename (opt, uword, nnul)
p.all   equ     $c      ; status cf clear field in all editable records (long)
; errors
; itnf  invalid bufferid
; any error from IMPL
cod_FLDC xsub
        regsave d1/d2/a3-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        ; get fieldid in d2
        move.w  p.fld+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2

        ; now see if fieldid is valid
        move.l  b_file(a4),a3   ; we need the filedata
        move.w  d2,d1           ; take copy of fid to use
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        tst.w   (a3)            ; does this field exist ?
        beq.s   codend          ; no it doesn't (no error)

        tst.l   p.all(a5)       ; clear all records ??
        bne.s   all
        xjsr    delfld          ; clear the field
        bra.s   codend
all     bsr.s   clrall          ; clear field in all records
codend  subend
;
; routine to clear field (id in d2) in all records in the file which are available
; needs bufferid in a4, parameterlist in a1
clrall  xsub
        regsave d1/d7/a3/a5
        xjsr    delfld          ; first delete in current record
        xjsr    cod_IMPL        ; first implement current record
        bne.s   allend          ; oops

        ; now "run" through all the records, and clear the field !!
        ; corrupts a3/a5/d7 (have to be preserved during "run")
        move.l  b_file(a4),a3   ; we need the fileid
        move.l  f_area(a3),d1   ; place in list of areas
        beq.s   runend          ; no records to sort -> ..
run     move.l  d1,a5
        moveq   #99,d7          ; nr of linkages to run through
        lea     4(a5),a3        ; first record linkage
runlp   cmpi.l  #-1,rl_id(a3)   ; linkage used ??
        beq.s   runnxt

        ; get the record in the buffer !!
        move.l  rl_id(a3),d1    ; recordid
        xjsr    GREC            ; get the record
        bne.s   runnxt

        ; now clear the field
        xjsr    delfld          ; just do it (TM)
        ; and re-implement the record
        xjsr    cod_IMPL        ; just do it again (no TM)
        bne.s   allend          ; oops

runnxt  adda.w  #rl.len,a3      ; start of next linkage
        dbf     d7,runlp

        move.l  (a5),d1         ; next area ??
        bne     run             ; if there is one
runend
allend  subend
;
        end
