; routine to delete a field
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; delete a field
; only works if this is the only buffer working on the file
; the record in the buffer is implemented
; it is not known which record will end up in the buffer !!
; you can't delete the MEMO field !!
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; id of field to rename (opt, uword, nnul)
; errors
; itnf  invalid bufferid
; fdiu  this is not the only buffer using the file
; any error from IMPL
cod_FLDD xsub
        regsave d1/d2/a3-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        ; get fieldid in d2
        move.w  p.fld+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2
        beq.s   codend          ; we can't delete the MEMO field

        ; make sure this is the only buffer using the file
        moveq   #err.fdiu,d0    ; assume not
        tst.l   b_next(a4)      ; there can't be a next
        bne.s   codend          ; as this has to be the last one
        move.l  b_file(a4),a3   ; oops
        cmpa.l  f_buffer(a3),a4 ; and the first one
        bne.s   codend          ; oops

        ; now see if fieldid is valid
        moveq   #0,d0
        move.l  b_file(a4),a3   ; we need the filedata
        move.w  d2,d1           ; take copy of fid to use
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        tst.w   (a3)            ; does this field exist ?
        beq.s   codend          ; no it doesn't (no error)

        ; actually delete the field
        clr.w   (a3)            ; no type, no name

        xjsr    clrall          ; now delete the field in all the records
codend  subend
;
        end
