; garbage collection
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_qdos_sms
        include dev8_qdos_io
        include dev8_err
*
; garbage collection
; always : makes sure there are no buffers for jobs which don't exist
; when bufferid passed (NOT optional) and file is disk based, this routine will
;   make sure there is not more space between the record as specified by the IRS
;   and there will be an empty record in the buffer (same as NEWR)
; take care, a crash during this command can be desastreus
; parameters
p.id    equ     $4      ; bufferid or indexid (long word, optional)
; errors
; itnf  buffer- or indexid invalid
cod_GARB xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5           ; keep params
start
        xjsr    frstfid         ; get first fid in list !!
        beq     codend          ; no files -> nothing to do
filelp  move.l  d0,a3

        move.l  f_buffer(a3),d0 ; first buffer in list
bufflp  move.l  d0,a4           ; bufferid

        move.l  b_jobid(a4),d1  ; job to test for existance
        moveq   #0,d2           ; no idea about owner job
        moveq   #sms.injb,d0    ; get info on job (check for existance)
        trap    #do.sms2
        tst.l   d0              ; does owner job exist ?
        beq.s   buffnxt         ; yes -> test next buffer

        xjsr    unuse           ; unuse this buffer
        bra     start           ; see if there is another one

buffnxt move.l  b_next(a4),d0   ; next buffer to test
bnxt    bne     bufflp          ; if there is one

        move.l  f_next(a3),d0   ; next file to test buffers of
        bne     filelp          ; if there is one

        moveq   #0,d0           ; no error
        tst.w   p.id-4(a5)      ; is the bufferid parameter given
        beq     codend          ; no -> skip
        move.l  p.id(a5),a4     ; get the given id
        move.l  a4,d0
        xjsr    testbid         ; valid bufferid ?
        bne     codend          ; oops
        move.l  b_file(a4),a3   ; fileid
        tst.b   b_file(a3)      ; is it disk-based
        beq     codend          ; no -> ready

        ; make sure we can use the record buffer
        move.l  a5,a1
        xjsr    cod_NEWR

        ; now we have to remove the whitespace from the file
        mutex                   ; we need supervisor for safety
        move.l  f_chid(a3),a0   ; channel id for i/o access of file
        move.l  #26+512+4608,d6 ; filepos with OLD record
        move.l  #26+512+4608,d7 ; filepos for  NEW record
inilp   ; we have skipped some data to arrive at the next record !!
        move.l  d6,d1           ; new file position
        xjsr    iof_posa        ; position file pointer
        ; check the amount of IRS
        moveq   #-1,d5          ; no empty bytes just yet
irscnt  addq.l  #1,d5           ; one more byte of irs
        xjsr    iob_fbyt        ; get another one
        bne     done            ; oops
        addq.l  #1,d6           ; we have moved on a byte
        cmpi.b  #'R',d1         ; start of record reached
        bne.s   irscnt          ; no -> test next byte
        ; now the amount of irs is in d5
        moveq   #0,d4
        move.w  f_irsp(a3),d4   ; take irs in a long
        sub.l   d4,d5           ; get nr of bytes there are too much
        bgt.s   doit            ; positive -> start actual work
        ; ok, skip this record
        moveq   #1+4+4,d1       ; skip 5 bytes
        xjsr    iof_posr
        bne     ahum
        move.l  b_mem(a4),a1    ; buffer
        moveq   #4,d2           ; we need 4 bytes
        xjsr    iob_fmul        ; get them
        bne     ahum            ; oops
        add.l   #1+4+4+4,d6     ; skip record header
        add.l   (a1),d6         ; end of record
        bra     inilp           ; test next record

doit    ; now we will have to start shifting records !!
        subq.l  #1,d6           ; actual start of record (place with 'R')
        move.l  d6,d7           ; new place is same as old place
        sub.l   d5,d7           ; but the irs has to be correct
        bra.s   endirs
movelp  ; first set the irs on destination
        move.l  d7,d1
        xjsr    iof_posa        ; new file position
        bne     ahum
        ; save the IRS
        move.w  f_irsp(a3),d3   ; save inter record space
        subq.w  #1,d3           ; prepare for dbf
        bmi.s   endirs          ; if there is some irs
        cmp.l   d6,d7           ; make sure we don't add too much irs
        beq     inilp           ; all is equaled -> re-search large whitespace
irslp   moveq   #0,d1           ; bytes to send
        xjsr    iob_sbyt
        bmi     ahum
        addq.l  #1,d7           ; one byte further in file
        cmp.l   d6,d7           ; make sure we don't add too much irs
        beq     inilp           ; all is equaled -> re-search large whitespace
        dbf     d3,irslp
endirs 
        move.l  d6,d1           ; place to get record from
        xjsr    iof_posa        ; position file pointer
        bne     trunc           ; we may have finished
white   addq.l  #1,d6           ; we will end up a byte further in the file
        xjsr    iob_fbyt        ; get another one
        bne     trunc           ; oops
        cmpi.b  #'R',d1         ; start of record reached
        bne.s   white           ; no -> test next byte
        ; read record header
        move.l  b_mem(a4),a1    ; start of buffer
        move.b  #'R',(a1)+      ; just prepare for writing
        moveq   #1+4+4+4,d2     ; nr of bytes to fetch
        xjsr    iob_fmul        ; get them
        bne     ahum            ; oops
        add.l   #1+4+4+4,d6     ; we are now a bit further in the file
        move.l  b_mem(a4),a1    ; place with buffer
        move.l  1+1+4+4(a1),d5  ; record length
        move.l  1+1(a1),d1      ; recordid
        xjsr    findrec         ; get ptr to recordlinkage in a1
        bne.s   ahum
        move.l  d7,rl_pos(a1)   ; new position of record in file
        move.l  d7,d1           ; new position for record
        xjsr    iof_posa
        bne.s   ahum
        move.l  b_mem(a4),a1    ; place with buffer
        moveq   #1+1+4+4+4,d2   ; nr of bytes
        xjsr    iob_smul        ; write record header
        bne.s   ahum
        add.l   #1+1+4+4+4,d7   ; place for actual record
        move.l  b_mem(a4),a1    ; place with buffer
reclp   ; write the record to the file
        move.l  d6,d1           ; position for reading
        xjsr    iof_posa
        bne.s   ahum
        move.l  b_mlen(a4),d4   ; available space for buffering
        move.l  d5,d2           ; assume we can buffer entire record (or what's left)
        cmp.l   d4,d5           ; can we load the entire record at once
        ble.s   fits            ; yes we can
        move.l  d4,d2           ; available space
fits    xjsr    iob_fmul        ; get the record
        bne.s   ahum            ; oops
        ; write it back to file
        move.l  d7,d1           ; position for writing
        xjsr    iof_posa
        bne.s   ahum
        xjsr    iob_smul        ; now write those bytes
        bne.s   ahum
        add.l   d2,d7           ; we are a bit further in the file (new rec)
        add.l   d2,d6           ; new place in file (old rec)
        sub.l   d2,d5           ; nr of bytes to go in record
        bgt     reclp           ; >0 -> write the rest
        bra     movelp          ; handle the other records

trunc   cmpi.l  #err.eof,d0     ; end of file reached
        bne.s   ahum            ; no -> report error
        endmutex
        move.l  d7,d1
        xjsr    iof_posa        ; position file pointer
        moveq   #iof.trnc,d0
        moveq   #forever,d3
        trap    #do.io          ; truncate file
        xjsr    iof_flsh
        bra.s   codend

done    cmpi.l  #err.eof,d0     ; end of file reached
        bne.s   ahum            ; no -> report error
        moveq   #0,d0           ; we don't have to report this error
ahum    endmutex                ; back to normal processor state
        move.l  d0,d7           ; keep error
        xjsr    iof_flsh        ; flush file
        move.l  d7,d0           ; restore error
codend
        subend
;
        end
