; routine to get the contents of an entire field
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; get the contents of an entire field
; if field is not found, 0 returned as length
; fieldid is not checked to be valid
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fid   equ     $8      ; fieldid (uword)
p.len   equ     $c      ; length of buffer (ulong)
p.place equ     $14     ; ptr to place to fill in field (ptr, has to be passed, doesn't have to be even)
p.ret   equ     $1c     ; length of field (return, ulong, has to be passed)
; errors
; itnf  invalid bufferid
;       field not found, this means that either an invalid fieldid was passed,
;       or that this is a NULL field in this record
; bffl  buffer full
cod_GFLD xsub
        regsave d1/d2/a1/a2/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.l  b_mem(a4),a1    ; start of record
        move.l  b_rlen(a4),d1   ; recordlen
        move.b  p.fid+3(a5),d2  ; fieldid
        xjsr    findfld         ; find it
        bne.s   codend          ; problem -> report error

        ; now fill in the buffer
        move.l  rf_len(a1),d1   ; fieldlength
        cmp.l   p.len(a5),d1    ; does it fit
        bmi.s   ok              ; yes ..
        move.l  p.len(a5),d1    ; other length
        moveq   #err.bffl,d0    ; and buffer full error
ok
        move.l  p.ret(a5),a2    ; fill in field langth as return
        move.l  d1,(a2)

        move.l  p.place(a5),a2  ; place to fill in the field
        lea     rf_fld(a1),a1
loop    move.b  (a1)+,(a2)+     ; copy a byte
        subq.l  #1,d1           ; another one ?
        bgt     loop
codend
        subend
;
        end
