; get record with given recordid
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
        include dev8_qdos_io
*
; get record with given recordid
; view only files always get the record, even if it is locked!!
; nothing happens when the current record is requested !!
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.rid   equ     $8      ; recordid (ulong)
; errors
; itnf  buffer id invalid
;       or record not found (invalid recordid)
; imem  out of memory
; fdiu  record is in use
cod_GREC xsub
        regsave d1/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   grecend         ; if not -> error

        move.l  p.rid(a5),d1    ; recordid
        bsr.s   GREC            ; get record
grecend subend
;
; get record, needs a4 bufferid, d1 recordid
GREC    xsub
        regsave d1-d3/d7/a0-a5
        moveq   #0,d0
        tst.b   b_new(a4)       ; is there a record in the buffer
        bne.s   grec_
        cmp.l   b_id(a4),d1     ; is the requested record in the buffer ??
        beq     codend          ; yes -> do nothing
grec_   move.l  d1,d7           ; keep d1
        mutex
        move.l  b_file(a4),a3   ; fileid
        xjsr    findrec         ; retrieve the requested record
        bne     ahum            ; oops, invalid recordid

        tst.b   b_view(a4)      ; view only file ??
        bne.s   always          ; then don't check if locked

        moveq   #err.fdiu,d0    ; assume record is in use
        tst.b   rl_edit(a1)     ; test it
        bne     ahum            ; oops, can't use this one
always  moveq   #0,d0

        tst.b   f_file(a3)      ; file based
        bne     fcopy           ; get it from file

        ; so now copy the record
        move.l  b_mlen(a4),d1   ; length of buffer memory
        move.l  rl_pos(a1),a2   ; record position in memory
        cmp.l   r_len(a2),d1    ; does it fit ?
        bpl.s   copy            ; yes -> just copy the lot
        ; now allocate a new buffer
        move.l  r_len(a2),d1    ; length that we need
        addi.l  #255,d1         ; round up to multiple of 256 bytes
        andi.w  #$fff0,d1
        xjsr    getsmem         ; and allocate it
        bne.s   ahum            ; oops, not enough memory
        move.l  d1,b_mlen(a4)   ; new buffer length
        move.l  a2,-(sp)
        move.l  b_mem(a4),a2    ; old area
        move.l  a0,b_mem(a4)    ; new area
        move.l  a2,a0
        xjsr    relmem          ; release old area
        move.l  (sp)+,a2
copy    ; now just copy the record
        move.b  r_mark(a2),b_mark(a4)   ; copy mark status
        move.l  r_len(a2),d1    ; length of record
        move.l  d1,b_rlen(a4)   ; fill it in

        lea     r_fld(a2),a2    ; actual start of record
        move.l  b_mem(a4),a0    ; where to put it
        lsr.l   #1,d1           ; get nr of words
cpylp   move.w  (a2)+,(a0)+     ; copy it
        subq.l  #1,d1           ; another ?
        bgt.s   cpylp

        ; and set 'edit' status of this record
sedit   tst.b   b_view(a4)      ; read only ?
        bne.s   clear           ; yes -> no problem
        move.b  #1,rl_edit(a1)  ; record is being edited
        tst.b   b_new(a4)       ; was this a new record ?
        bne.s   clear           ; yes -> ok
        ; now clear the edited status of the record
        move.l  b_id(a4),d1     ; recordid
        move.l  b_file(a4),a3   ; fileid
        xjsr    findrec         ; find record
        clr.b   rl_edit(a1)     ; not edited any more
clear   ; and fill in recordid
        move.l  d7,b_id(a4)     ; fill in recordid
        clr.b   b_new(a4)       ; not new
ahum    endmutex
codend  subend

fcopy   ; get the actual record from the file
        move.l  f_chid(a3),a0   ; channel id
        move.l  a1,a2
        move.l  rl_pos(a1),d1   ; file position
        xjsr    iof_posa        ; position file pointer
        bne     ahum
        xjsr    iob_fbyt        ; get a byte
        bne     ahum
        moveq   #err.itnf,d0
        cmp.b   #'R',d1         ; has to mark start of record
        bne     ahum            ; this should never happen
        xjsr    iob_fbyt
        bne     ahum
        move.b  d1,b_mark(a4)   ; set mark status for this record
        move.l  rl_pos(a1),d1   ; file position
        addi.l  #10,d1          ; skip 'R'.b, mark.n, id.l,date.l
        xjsr    iof_posa
        bne     ahum            ; ahum...

        ; read record length
        moveq   #0,d2           ; clear record len
        xjsr    iob_fbyt
        bne     ahum
        move.b  d1,d2
        xjsr    iob_fbyt
        bne     ahum
        lsl.l   #8,d2
        move.b  d1,d2
        xjsr    iob_fbyt
        bne     ahum
        lsl.l   #8,d2
        move.b  d1,d2
        xjsr    iob_fbyt
        bne     ahum
        lsl.l   #8,d2
        move.b  d1,d2

        move.l  b_mlen(a4),d1   ; length of buffer memory
        cmp.l   d2,d1           ; does it fit ?
        bpl.s   load            ; yes -> just copy the lot
        ; now allocate a new buffer
        move.l  d2,d1           ; length that we need
        addi.l  #255,d1         ; round up to multiple of 256 bytes
        andi.w  #$fff0,d1
        xjsr    getsmem         ; and allocate it
        bne     ahum            ; oops, not enough memory
        move.l  d1,b_mlen(a4)   ; new buffer length
        move.l  a2,-(sp)
        move.l  b_mem(a4),a2    ; old area
        move.l  a0,b_mem(a4)    ; new area
        move.l  a2,a0
        xjsr    relmem          ; release old area
        move.l  (sp)+,a2
load
        ; fill it in (length in d2)
        move.l  d2,b_rlen(a4)   ; fill in record length
        move.l  b_mem(a4),a1    ; base of buffer
        move.l  f_chid(a3),a0   ; channel id
        xjsr    iob_fmul
        bne     ahum            ; ahum...
        move.l  a2,a1           ; record linkage
        bra     sedit           ; now finish this (set edit status)
;
        end
