; index delete
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
*
; index delete
; the record in the buffer will be deleted from the index if it can be found
; the record should not have sighnificantly changed for this !!
; parameters
p.id    equ     $4	    ; buffer id or indexid (long word, optional)
; errors
; imem  out of memory
cod_IDEL xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5	  ; keep params in a safe place

        move.l  p.id(a5),d0	  ; buffer id if passed
        move.l  d0,a2	  ; or it can be the indexid
        tst.w   p.id-4(a5)	  ; is the buffer id given ?
        bne.s   tbuff	  ; yes -> ..
        xjsr    getbuff	  ; get default buffer
tbuff   move.l  d0,a4	  ; keep it
        xjsr    testbid	  ; and test if it is valid
        bne.s   tindex	  ; if not -> try it as an index
        move.l  b_dindex(a4),a2 ; take default index
tindex  move.l  a2,d0
        beq.s   codend	  ; no index -> nothing to do
        xjsr    testiid	  ; see if it is valid
        bne.s   codend
        move.l  i_buffer(a2),a4 ; make sure buffer id is valid

        tst.b   b_new(a4)	  ; is this a new record
        bne.s   codend	  ; -> nothing to do

        ; NOW WE HAVE TO DELETE THIS RECORD
        ; we need an empty index linkage
        move.l  i_free(a2),d1   ; is there one ?
        bne.s   gotfree	  ; yes -> ...
        xjsr    getifree	  ; get free index linkages
gotfree ; now use one of these links
        ; fill in the index linkage
        move.l  i_free(a2),a1
        xjsr    fillil	  ; needs a1 index linkage, a4 bufferid, a2 index

        ; now we have to delete it
        ; linkout is recursive routine to delete a record in the index
linkregs reg    d6/a0/a2
        movem.l linkregs,-(sp)
        move.w  i_len(a2),d3	  ; length of compare block
        subq.w  #1,d3

        lea     i_top(a2),a0
        move.l  a0,-(sp)	  ; head pointer of tree
        move.l  i_free(a2),a3   ; linkage has to be in a3
        move.l  a2,a4	  ; indexid in a4
        moveq   #0,d2	  ; start with false
        bsr.s   linkout
; V. 3.16
	MOVE.L	#-1,il_id(A3)
;
        adda.w  #4,sp	  ; clean up stack
        move.l  a2,a1	  ; keep linkage for possible re-link
        movem.l (sp)+,linkregs

finish  moveq   #0,d0
codend
        subend
;
; delind is recursive routine to link a record out
; addr of ptr to list: on stack, a3 linkage to unlink, d2 boolean (false at start)
; needs indexid in a4, len of sortdata-1 in d3
; based on verwijder routine in "Algoritmen en datastructuren" p289
; can corrupt a0-a2/d0-d2
p.ptr   equ     $4		  ; place, relative to stack where we can find the head ptr of the tree
linkout
        move.l  p.ptr(sp),a0	  ; ptr to head ptr
        tst.l   (a0)	  ; zero ?
        beq.s   elink	  ; yes -> nothing to unlink
        move.l  (a0),a0	  ; current linkage
        ; compare linkages
        move.w  d3,d1	  ; for loop
        bmi.s   nmrk	  ; oops, only compare recordid's (no sort)
        lea     il_index(a0),a0
        lea     il_index(a3),a5
        moveq   #0,d4	  ; clear high word for compare without sign
        moveq   #0,d5
cloop   move.w  (a0)+,d4	  ; compare a word
        move.w  (a5)+,d5
        cmp.l   d4,d5
        bgt.s   right	  ; link to the right
        blt.s   left	  ; link to the left
        dbf     d1,cloop	  ; or compare next
			  ; if all equal, order of recordid
nmrk    ; consider the order of the recordid's
        move.l  il_id(a3),d1	  ; id of new record
        move.l  p.ptr(sp),a0	  ; ptr to head ptr
        move.l  (a0),a0	  ; current linkage
        cmp.l   il_id(a0),d1	  ; compare with top of tree
        bgt.s   right	  ; link to the right
        blt.s   left	  ; link to the left
			  ; oops, equal
        bra.s   equal	  ; so delete it !!

left    move.l  p.ptr(sp),a0	  ; ptr to head ptr
        move.l  (a0),a0	  ; current linkage
        lea     il_left(a0),a0
        move.l  a0,-(sp)	  ; head pointer of tree (left branche)
        jsr     linkout	  ; !! no register values are preserved !! (recursive call)
        adda.w  #4,sp	  ; clean up stack
        move.l  p.ptr(sp),a0	  ; and restore pointer
        move.l  (a0),a0	  ; to value as at the start
        tst.b   d2		  ; has there been any growth ?
        beq.s   elink	  ; no -> in balance
        bsr     balansL	  ; breng links in balans
        move.l  p.ptr(sp),a1
        move.l  a0,(a1)
elink   rts

right   move.l  p.ptr(sp),a0	  ; ptr to head ptr
        move.l  (a0),a0	  ; current linkage
        lea     il_right(a0),a0
        move.l  a0,-(sp)	  ; head pointer of tree (left branche)
        jsr     linkout	  ; !! no register values are preserved !! (recursive call)
        adda.w  #4,sp	  ; clean up stack
        move.l  p.ptr(sp),a0	  ; and restore pointer
        move.l  (a0),a0	  ; to value as at the start
        tst.b   d2		  ; has there been any growth ?
        beq     elink	  ; no -> in balance
        bsr     balansR	  ; breng links in balans
        move.l  p.ptr(sp),a1
        move.l  a0,(a1)
        rts
equal   move.l  p.ptr(sp),a1
        tst.l   il_right(a0)
        bne.s   eq1
        move.l  il_left(a0),(a1)
        moveq   #1,d2
        bra.s   rel
eq1     tst.l   il_left(a0)
        bne.s   eq2
        move.l  il_right(a0),(a1)
        moveq   #1,d2
        bra.s   rel
eq2     move.l  a0,-(sp)	  ; keep p for a while, and use q
        move.l  il_left(a0),a1
        bsr.s   weg
        move.l  a0,d0	  ; beware, q may have changed
        move.l  (sp)+,a0	  ; we we need to set it in the old one
        move.l  a1,il_left(a0)
        move.l  d0,-(sp)	  ; this is the one we will have to release
        tst.b   d2
        beq.s   rel2
        bsr.s   balansL	  ; breng links in balans
        move.l  p.ptr+4(sp),a1
        move.l  a0,(a1)
rel2    move.l  (sp)+,a0
rel     ; release the record with record linkage in a0
        move.l  i_free(a4),(a0) ; link into free record linkages
        move.l  a0,i_free(a4)
        move.l  #-1,il_id(a0)   ; unused linkage
        ; and we have one less record in the index
        subq.l  #1,i_count(a4)
        rts

weg     ; parameters a1 ptr, d2 boolean
        tst.l   il_right(a1)
        beq.s   weg1
        move.l  a1,-(sp)
        move.l  il_right(a1),a1
        bsr     weg
        move.l  a1,d1
        move.l  (sp)+,a1
        move.l  d1,il_right(a1)
        tst.b   d2
        beq.s   weg2
        exg     a0,a1
        move.l  a1,-(sp)	  ; we have to reserve a1
        bsr     balansR	  ; breng links in balans
        move.l  (sp)+,a1
        exg     a0,a1
        rts
weg1
        move.l  il_id(a1),il_id(a0)
        move.w  d3,d1
        bmi.s   wegec
        add.w   d1,d1
wegclp  move.w  il_index(a1,d1.w),il_index(a0,d1.w)
        subq.w  #2,d1
        bpl.s   wegclp
wegec   move.l  a1,a0
        move.l  il_left(a1),a1
        moveq   #1,d2
weg2    rts

balansL ; returns in a1, the new value for p
        ; so a1 -> (p.ptr(sp))
        tst.b   il_avl(a0)
        beq.s   bL0
        bpl.s   bL1
        clr.b   il_avl(a0)
        rts
bL0     move.b  #1,il_avl(a0)
        moveq   #0,d2
        rts
bL1     ; herbalanceren
        move.l  il_right(a0),a1
        move.b  il_avl(a1),d0
        bmi.s   RL
        ; enkelvoudig RR roteren
        move.l  il_left(a1),il_right(a0)
        move.l  a0,il_left(a1)
        tst.b   d0
        bne.s   RRel
        move.b  #1,il_avl(a0)
        move.b  #-1,il_avl(a1)
        moveq   #0,d2
        bra.s   RRen
RRel    move.b  #0,il_avl(a0)
        move.b  #0,il_avl(a1)
RRen    move.l  a1,a0
        rts
RL      ; dubbel RL roteren
        move.l  il_left(a1),a2
        move.b  il_avl(a2),d1
        move.l  il_right(a2),il_left(a1)
        move.l  a1,il_right(a2)
        move.l  il_left(a2),il_right(a0)
        move.l  a0,il_left(a2)
        tst.b   d1
        ble.s   RLel1
        move.b  #-1,il_avl(a0)
        bra.s   RLen1
RLel1   clr.b   il_avl(a0)
RLen1   tst.b   d1
        bpl.s   RLel2
        move.b  #1,il_avl(a1)
        bra.s   RLen2
RLel2   clr.b   il_avl(a1)
RLen2   clr.b   il_avl(a2)
        move.l  a2,a0
        rts

balansR ; returns in a1, the new value for p
        ; so a1 -> (p.ptr(sp))
        tst.b   il_avl(a0)
        beq.s   bR0
        bmi.s   bR_1
        clr.b   il_avl(a0)
        rts
bR0     move.b  #-1,il_avl(a0)
        moveq   #0,d2
        rts
bR_1    ; herbalanceren
        move.l  il_left(a0),a1
        move.b  il_avl(a1),d0
        bgt.s   LR
        ; enkelvoudig LL roteren
        move.l  il_right(a1),il_left(a0)
        move.l  a0,il_right(a1)
        tst.b   d0
        bne.s   LLel
        move.b  #-1,il_avl(a0)
        move.b  #1,il_avl(a1)
        moveq   #0,d2
        bra.s   LLen
LLel    move.b  #0,il_avl(a0)
        move.b  #0,il_avl(a1)
LLen    move.l  a1,a0
        rts
LR      ; dubbel LR roteren
        move.l  il_right(a1),a2
        move.b  il_avl(a2),d1
        move.l  il_left(a2),il_right(a1)
        move.l  a1,il_left(a2)
        move.l  il_right(a2),il_left(a0)
        move.l  a0,il_right(a2)
        tst.b   d1
        bpl.s   LRel1
        move.b  #1,il_avl(a0)
        bra.s   LRen1
LRel1   clr.b   il_avl(a0)
LRen1   tst.b   d1
        ble.s   LRel2
        move.b  #-1,il_avl(a1)
        bra.s   LRen2
LRel2   clr.b   il_avl(a1)
LRen2   clr.b   il_avl(a2)
        move.l  a2,a0
        rts
;
        end
