; routine to get the fieldid when a fieldname is given
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
        include dev8_ext_thg
*
; get fieldid when fieldname given (case dependant)
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.name  equ     $c      ; name of new field (string or substring)
p.ret   equ     $14     ; return field id (uword)
; errors
; itnf  buffer id invalid
;       fieldname not found
; inam  null name is not a valid fieldname
cod_IDFI xsub
        regsave d1/d2/a1-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.l  b_file(a4),a4   ; we only need to know the fileid

        ; make sure a fieldname is given
        ; and put start of name in a2
        ; and length in d2
        moveq   #err.inam,d0    ; assume invalid name
        move.w  p.name-4(a5),d1 ; type of parameter
        beq.s   codend          ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   codnstr         ; no -> ..
        move.l  p.name(a5),a2   ; ptr to name
        move.w  (a2)+,d2        ; string length
        beq.s   codend          ; if zero -> no field to include
        bra.s   codcps          ; copy string
codnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   codend
        move.w  p.name-2(a5),d2 ; string length
        beq.s   codend          ; if zero -> no field to include
        move.l  p.name(a5),a2   ; ptr to name
codcps

        bsr.s   get_idfi        ; test the name, returns fieldid (.l) or error code
        bmi.s   codend          ; error -> don't return a thing

        move.l  p.ret(a5),a1    ; place to fill in return value
        move.w  d0,(a1)         ; fill in return value
        moveq   #0,d0           ; no error
codend
        subend
;
; routine to search a fieldname, and return the fieldid, or an error code (err.itnf)
; needs : fileid in a4, string start in a2, string length in d2
get_idfi xsub
        regsave d1/d3/d4/a3
        cmpi.w  #17,d2          ; fieldname can only be 16 chars long
        bpl.s   itnf            ; longer than 16 -> we can't find it
        move.w  #255,d1         ; nr of fields to test
        lea     f_fields(a4),a3 ; start of field data
        moveq   #0,d0           ; start with fieldid 0

lp      cmp.b   1(a3),d2        ; zelfde lengte ?
        bne.s   nxt             ; neen -> volgende

        move.w  d2,d3           ; even string lengte nemen voor vgl
        subq.w  #1,d3           ; aanpassen dbf
cmp     move.b  2(a3,d3.w),d4   ; compare
        cmp.b   0(a2,d3.w),d4   ; same ?
        bne.s   nxt             ; no, try the next fieldid
        dbf     d3,cmp          ; compare next char
        bra.s   getend          ; if we get here then we found the fieldid we're looking for

nxt     adda.w  #18,a3          ; volgende nemen
        addq.w  #1,d0           ; test next fieldid
        dbf     d1,lp           ; nog een ?
itnf    moveq   #err.itnf,d0    ; no -> not found
getend
        subend
;
        end
