
; find an item in an index for a text field if the first 1...8 chars match
; written for DATAdesign engine v2.+ (wl - version 1.00 - 2000 Nov 09)
; (c)1992-93 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; find an item in an index for a text field if the first 1...8 chars match
; parameters
p.id    equ     $4      ; buffer id or indexid (long word, optional)
p.item  equ     $8      ; 8.b value to find, LEFT JUSTIFIED (char passed as word)!!
p.ret   equ     $14     ; ret ulong recordid of first item in index
; errors
; itnf  invalid buffer or indexid
; orng  field was not a text (char) field
; ipar  there was no text given to compare with
; eof   there was no match
;       (ret=close match)
cod_IFDS        xsub
        regsave d1-d7/a1-a5
        move.l  p.item(a1),-(sp)        ; make sure we can restore the call parameters
        move.l  p.item+4(a1),-(sp)
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a2           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   ti              ; oops -> see if it is an index
        move.l  b_index(a2),a2  ; take default index
ti      move.l  a2,d0
        xjsr    testiid         ; is it an indexid ?
        bne.s   codend          ; no -> forget it

        ; give item to find a suitable conversion
        ; also get mask into D6 & D5
        ; and data to search for into D3 & D4
        bsr.s   cmplen
        bne.s   codend          ; oops->...

        ; initialise return
        move.l  p.ret(a5),a1    ; place for it
        move.l  #-1,(a1)                ; fill in - none yet

        ; now do search - compare 8 bytes (!)
        MOVE.L  i_top(A2),D0    ; top of tree
loop1   BEQ.S   done            ; end reached
        MOVEA.L D0,A0           ; index linkage
        LEA     il_index(A0),A3 ; place to compare
compare MOVE.L  (A3)+,D0                ; index data: first 4 bytes
        AND.L   D5,D0           ; mask n1
        CMP.L   D0,D3           ; compare
        BGT.S   right           ; if indexdata is right
        BLT.S   left            ; if indexdata is left
        MOVE.L  (A3)+,D0                ; index data: second 4 bytes
        AND.L   D6,D0           ; now mask 2
        CMP.L   D0,D4           ; compare
        BGT.S   right           ; if indexdata is right
        BLT.S   left            ; if indexdata is left
; here a matching record is found. See whether the one before that also matches
        MOVE.L  il_id(A0),(A1)  ; get the record ID


left    MOVE.L  il_left(A0),D0  ; get previous record in index
        BRA.S   loop1
right   MOVE.L  il_right(A0),D0 ; get next
        BRA.S   loop1


done    moveq   #0,d0           ; preset no error
        cmpi.l  #-1,(a1)                ; or couldn't we find it  ?
        bne.s   codend          ; yes, we could ->...
        move.l  il_id(a0),(a1)  ; fill in the closest match (why?)
        moveq   #err.eof,d0     ; oops, not found, even though I searched whole file for it
codend
        move.l  (sp)+,p.item+4(a1)
        move.l  (sp)+,p.item(a1)
        subend


; give item to find a suitable conversion
cmplen  subr
        regsave d1/d2/a0/a2-a3/a5
        lea     p.item(a5),a5   ; item to adjust
        lea     i_sort(a2),a0   ; start of sort data
        tst.b   i_fti(a0)       ; is this level present
        beq     fillend         ; no -> finished
        ; first find the field
        cmpi.b  #ft.char,i_fti(a0)      ; is it a text field?
        bmi.s   ftext           ; yes ->...
        beq.s   fchar           ; a char field will do ->...
        MOVEQ   #err.orng,D0    ; not the right field type!
        BRA.S   fillend

fchar   ; fill in a char to sort
        move.w  (a5),d1
        btst    #c..rvrs,i_cmp+1(a0)
        beq.s   fcf
        eori.b  #$ff,d1
        MOVE.L  A5,A0
fcf     move.w  d1,(a5)+
        moveq   #1,d2           ; there is one char only
        bra.s   gmask

ftext   ; fill in 8-chars to sort
        move.l  i_buffer(a2),a2
        move.l  b_file(a2),a2
        lea     f_order3(a2),a2
        btst    #c..case,i_cmp+1(a0)
        beq.s   ftcase
        suba.w  #512,a2
ftcase  btst    #c..rvrs,i_cmp+1(a0)
        beq.s   ftrvrs
        adda.w  #256,a2
ftrvrs
ftxt    ; now just convert the item
        MOVEQ   #7,D6           ; we need to copy 8 bytes (dbf)
        MOVEQ   #0,D2           ; counter
        MOVEQ   #0,D1
        MOVE.L  A5,A0
ftclp   MOVE.B  (A5),D1         ; get the char
        BEQ.S   gmask           ; stop when we encounter a zero
        MOVE.B  0(A2,D1.W),(A5)+        ; set the equivalent code
        ADDQ.W  #1,D2           ; char counter
        DBF     D6,ftclp                ; another char ??

; now get the masks
gmask   MOVEQ   #err.ipar,D0    ; preset error
        SUBQ.W  #1,D2           ; any char?
        BMI.S   fillend         ; no! ->...
        LSL.L   #3,D2           ; *8, 2 longwords for each elmt of table
        LEA     mytable,A2      ; point to table
        MOVE.L  (A2,D2.W),D5    ; get mask n 1
        MOVE.L  4(A2,D2.W),D6   ; get mask n 2
        MOVE.L  (A0),D3         ; first 4 bytes of chars
        MOVE.L  4(A0),D4                ; last 4 bytes of chars
        AND.L   D5,D3           ; mask the unwanted ones
        AND.L   D6,D4           ; "     "    "       "
        MOVEQ   #0,D0           ; no error
fillend subend

; MASKS
mytable DC.L    $FF000000,$00000000 ; masks for string with 1 char in it
        DC.L    $FFFF0000,$00000000 ; 2 chars
        DC.L    $FFFFFF00,$00000000 ; 3 chars etc...
        DC.L    $FFFFFFFF,$00000000
        DC.L    $FFFFFFFF,$FF000000
        DC.L    $FFFFFFFF,$FFFF0000
        DC.L    $FFFFFFFF,$FFFFFF00
        DC.L    $FFFFFFFF,$FFFFFFFF ; all 8 chars are there


        END
