; find an item in an index
; written for DATAdesign engine v2.+
; (c)1992-93 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
        include dev8_k
*
; find an item in an index
; parameters
p.id    equ     $4      ; buffer id or indexid (long word, optional)
p.item  equ     $8      ; 8.b value to find, LEFT JUSTIFIED (char passed as word)!!
p.ret   equ     $14     ; ret ulong recordid of first item in index
; errors          4
; itnf  invalid buffer or indexid
;       not found (ret=close match)
cod_IFND xsub
        regsave d1/d3/d4/d7/a1-a5
        move.l  p.item(a1),-(sp); make sure we can restore the call parameters
        move.l  p.item+4(a1),-(sp)
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a2           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   ti              ; oops -> see if it is an index
        move.l  b_index(a2),a2  ; take default index
ti      move.l  a2,d0
        xjsr    testiid         ; is it an indexid ?
        bne.s   codend          ; no -> forget it

        ; determine nr of words to compare (d7)
        ; and give item to find a suitable conversion
        bsr.s   cmplen
        bne.s   codend          ; there should be no error
        subq.w  #1,d7           ; adjust for dbf
        bmi.s   done

        ; initialise return
        move.l  p.ret(a5),a1    ; place for it
        move.l  #-1,(a1)        ; fill in

        ; ok, now look for the requested recordid
        move.l  i_top(a2),d0    ; top of tree
findlp  beq.s   done            ; end reached
        move.l  d0,a0           ; index linkage
        lea     il_index(a0),a3 ; place to cmp
        lea     p.item(a5),a4   ; item to search
        move.w  d7,d1           ; for loop
        moveq   #0,d3           ; clear high word for compare without sign
        moveq   #0,d4
cloop   move.w  (a3)+,d3        ; compare a word
        move.w  (a4)+,d4
        cmp.l   d3,d4
        bgt.s   right           ; link to the right
        blt.s   left            ; link to the left
        dbf     d1,cloop        ; or compare next
                                ; if all equal, this is a good one, and continue left
        move.l  il_id(a0),(a1)  ; fill in return id
left    move.l  il_left(a0),d0  ; take left branch
        bra.s   findlp
right   move.l  il_right(a0),d0 ; take right branch
        bra.s   findlp

done    moveq   #0,d0           ; no error
        cmpi.l  #-1,(a1)        ; or couldn't we find it
        bne.s   codend
        move.l  il_id(a0),(a1)  ; fill in the closest match
        moveq   #err.itnf,d0    ; oops, not found
codend
        move.l  (sp)+,p.item+4(a1)
        move.l  (sp)+,p.item(a1)
        subend

; get nr of words we have to compare in d7
; and give item to find a suitable conversion
cmplen  subr
        regsave d1/d2/d6/a0/a2/a5
        lea     p.item(a5),a5   ; item to adjust
        lea     i_sort(a2),a0   ; start of sort data
        tst.b   i_fti(a0)       ; is this level present
        beq     fillend         ; no -> finished
        ; first find the field
        cmpi.b  #ft.char,i_fti(a0)
        bmi     ftext
        beq.s   fchar
        cmpi.b  #ft.long,i_fti(a0)
        bmi.s   fshort
        beq.s   flong
fdouble ; fill in a double to sort
        move.l  (a5),d1
        move.l  4(a5),d2
        btst    #31,d1          ; negative number
        bne.s   fdn             ; yes -> ok
        eori.l  #$7fffffff,d1   ; reverse the order for the positive doubles
        eori.l  #$ffffffff,d2
fdn     btst    #c..rvrs,i_cmp+1(a0)
        bne.s   fdf             ; reverse -> all is ok
        eori.l  #$ffffffff,d1
        eori.l  #$ffffffff,d2
fdf     move.l  d1,(a5)+
        move.l  d2,(a5)+
        moveq   #4,d7           ; double word is 4 words
        bra     fillend

flong   ; fill in a long to sort
        move.l  (a5),d1
        btst    #c..rvrs,i_cmp+1(a0)
        beq.s   flf
        eori.l  #$ffffffff,d1
flf     subi.l  #$80000000,d1
        move.l  d1,(a5)+
        moveq   #2,d7           ; long is 2 words
        bra.s   fillend

fshort  ; fill in a short to sort
        move.w (a5),d1
        btst    #c..rvrs,i_cmp+1(a0)
        beq.s   fsf
        eori.w  #$ffff,d1
fsf     subi.w  #$8000,d1
        move.w  d1,(a5)+
        moveq   #1,d7           ; word is 1 word
        bra.s   fillend

fchar   ; fill in a char to sort
        move.w  (a5),d1
        btst    #c..rvrs,i_cmp+1(a0)
        beq.s   fcf
        eori.b  #$ff,d1
fcf     move.w  d1,(a5)+
        moveq   #1,d7           ; char is 1 word
        bra.s   fillend

ftext   ; fill in 8-chars to sort
        moveq   #4,d7           ; text is 4 words
        move.l  i_buffer(a2),a2
        move.l  b_file(a2),a2
        lea     f_order3(a2),a2
        btst    #c..case,i_cmp+1(a0)
        beq.s   ftcase
        suba.w  #512,a2
ftcase  btst    #c..rvrs,i_cmp+1(a0)
        beq.s   ftrvrs
        adda.w  #256,a2
ftrvrs
ftxt    ; now just convert the item
        moveq   #7,d6           ; we need to copy 8 bytes (dbf)
ftclp   moveq   #0,d1
        move.b  (a5),d1         ; get the char
        beq.s   fillend         ; stop when we encounter a zero
        move.b  0(a2,d1.w),(a5)+; set the equivalent code
        dbf     d6,ftclp        ; another char ??

fillend subend
;
        end
