; index implement
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
*
; index implement
; the record has to have been implemented in the file beforehand
; parameters
p.id    equ     $4      ; buffer id or indexid (long word, optional)
; errors
; imem  out of memory
cod_IIMP xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        move.l  d0,a2           ; or it can be the indexid
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   tindex          ; if not -> try it as an index
        move.l  b_dindex(a4),a2 ; take default index
tindex  move.l  a2,d0
        beq.s   codend          ; no index -> nothing to do
        xjsr    testiid         ; see if it is valid
        bne.s   codend
        move.l  i_buffer(a2),a4 ; then this is the buffer id
        move.l  b_file(a4),a3   ; we need the fileid

        tst.b   b_new(a4)       ; is this a new record
        bne.s   codend          ; -> nothing to do

        xjsr    recfilt         ; is this record visible ??
        beq.s   codend          ; no it isn't -> ..

        ; NOW WE HAVE TO LINK THIS RECORD IN
        ; we need an empty index linkage
        move.l  i_free(a2),d1   ; is there one ?
        bne.s   gotfree         ; yes -> ...
        xjsr    getifree        ; get free index linkages
gotfree ; now use one of these links
        ; fill in the index linkage
        move.l  i_free(a2),a1
        xjsr    fillil          ; needs a1 index linkage, a4 bufferid, a2 index

        ; now we have to link it
        ; linkind is recursive routine to link a record in the index
linkregs reg    d6/a0/a2/a5
        movem.l linkregs,-(sp)
        move.w  i_len(a2),d3    ; length of compare block
        subq.w  #1,d3
        move.w  i_sort+i_cmp(a2),d6     ; first compare level
        move.l  i_free(a2),a1
        move.l  il_next(a1),i_free(a2)  ; unlink the item
        lea     i_top(a2),a0
        move.l  a0,-(sp)        ; head pointer of tree
        move.l  a1,a2           ; linkage has to be in a2
        moveq   #0,d2           ; start with false
        xjsr    linkind
        adda.w  #4,sp           ; clean up stack
        move.l  a2,a1           ; keep linkage for possible re-link
        movem.l (sp)+,linkregs

        ; and we have an extra record in the index
        addq.l  #1,i_count(a2)
        tst.l   d0
        beq.s   finish

        ; we were unable to link it in
        linkin  i_free(a2),a1   ; re-link index linkage
        ; and we DON'T have an extra record in the index
        subq.l  #1,i_count(a2)

finish  moveq   #0,d0
codend
        subend
;
        end
