; implement the given buffer in the file
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include win1_inc_keys_err
*
; implement the given buffer in the file
; version for DEMO of engine, -> not implemented
; nimp  sorry, this is only a demo version
cod_IMPL xsub
        moveq   #err.nimp,d0
        subend
;
; linkin is recursive routine to link a record in
; addr of ptr to list: on stack, a2 linkage block (preserved), d2 boolean
; based on zoek routine in "Algoritmen en datastructuren" p284
; can corrupt a0/a1/a5 and d1
        xdef    linkin
p.ptr   equ     $4              ; place, relative to stack where we can find the head ptr of the tree
linkin
        move.l  p.ptr(sp),a0    ; ptr to head ptr
        tst.l   (a0)            ; zero ?
        bne.s   balance         ; no -> figure out a balanced tree
        move.l  a2,(a0)         ; fill in ptr
        clr.l   rl_left(a2)
        clr.l   rl_right(a2)
        clr.b   rl_avl(a2)
        moveq   #1,d2           ; branche has grown
elink   rts                     ; and that's it
balance
        move.l  (a0),a0         ; current linkage
        move.l  rl_id(a2),d1    ; id of new record
        cmp.l   rl_id(a0),d1    ; compare with top of tree
        bpl     right           ; continue with right branche
        lea     rl_left(a0),a0
        move.l  a0,-(sp)        ; head pointer of tree (left branche)
        jsr     linkin          ; !! no register values are preserved !! (recursive call)
        adda.w  #4,sp           ; clean up stack
        move.l  p.ptr(sp),a0    ; and restore pointer
        move.l  (a0),a0         ; to value as at the start
        tst.b   d2              ; has there been any growth ?
        beq     elink           ; no -> in balance
        tst.b   rl_avl(a0)      ; how WAS the balance
        beq.s   lcase0          ; when was zero
        bmi.s   lcase_1         ;          -1
lcase1  clr.b   rl_avl(a0)      ; balance is perfect
        moveq   #0,d2           ; no growth
        rts
lcase0  move.b  #-1,rl_avl(a0)  ; set balance
        rts
lcase_1 move.l  rl_left(a0),a1  ; set p1
        tst.b   rl_avl(a1)      ; check balance
        bpl.s   l_else          ; <> -1 -> ..
        ; enkelvoudig LL roteren
        move.l  rl_right(a1),rl_left(a0); p^.links=p1^.rechts
        move.l  a0,rl_right(a1) ; p1^rechts=p
        clr.b   rl_avl(a0)      ; clear balance
        move.l  p.ptr(sp),a0
        move.l  a1,(a0)         ; p=p1
        clr.b   rl_avl(a1)      ; also clear p^bal(=p1^bal)
        moveq   #0,d2           ; no growth
        rts
l_else  ; dubbel LR roteren
        move.l  a2,a5           ; keep a2 for a while
        move.l  rl_right(a1),a2 ; p2=p1^rechts
        move.l  rl_left(a2),rl_right(a1)
        move.l  a1,rl_left(a2)
        move.l  rl_right(a2),rl_left(a0)
        move.l  a0,rl_right(a2)
        clr.b   rl_avl(a0)      ; get balances figured out
        tst.b   rl_avl(a2)
        bpl.s   LR_1
        move.b  #1,rl_avl(a0)
LR_1    clr.b   rl_avl(a1)
        tst.b   rl_avl(a2)
        ble.s   LR_2
        move.b  #-1,rl_avl(a0)
LR_2
        move.l  p.ptr(sp),a1    ; get value for p
        move.l  a2,(a1)         ; p=p2
        clr.b   rl_avl(a2)      ; in balance p^bal=0 (p aangepast)
        moveq   #0,d2           ; no growth
        move.l  a5,a2           ; restore a2
        rts

right   lea     rl_right(a0),a0
        move.l  a0,-(sp)        ; head pointer of tree (right branche)
        jsr     linkin          ; !! no register values are preserved !! (recursive call)
        adda.w  #4,sp           ; clean up stack
        move.l  p.ptr(sp),a0    ; and restore pointer
        move.l  (a0),a0         ; to value as at the start
        tst.b   d2              ; has there been any growth ?
        beq     elink           ; no -> in balance
        tst.b   rl_avl(a0)      ; how WAS the balance
        bmi     lcase1          ; when was -1 , is same as 1 for other case
        bgt.s   rcase1          ; when was 1
rcase0  move.b  #1,rl_avl(a0)   ; set balance
        rts
rcase1  move.l  rl_right(a0),a1 ; set p1
        tst.b   rl_avl(a1)      ; check balance
        ble.s   r_else          ; <> 1 -> ..
        ; enkelvoudig RR roteren
        move.l  rl_left(a1),rl_right(a0); p^.rechts=p1^.links
        move.l  a0,rl_left(a1)  ; p1^links=p
        clr.b   rl_avl(a0)      ; clear balance
        move.l  p.ptr(sp),a0    ; get value for p
        move.l  a1,(a0)         ; p=p1
        clr.b   rl_avl(a1)      ; also clear p^bal(=p1^bal)
        moveq   #0,d2           ; no growth
        rts
r_else  ; dubbel RL roteren
        move.l  a2,a5           ; keep a2 for a while
        move.l  rl_left(a1),a2  ; p2=p1^links
        move.l  rl_right(a2),rl_left(a1)
        move.l  a1,rl_right(a2)
        move.l  rl_left(a2),rl_right(a0)
        move.l  a0,rl_left(a2)
        clr.b   rl_avl(a0)      ; get balances figured out
        tst.b   rl_avl(a2)
        ble.s   RL_1
        move.b  #-1,rl_avl(a0)
RL_1    clr.b   rl_avl(a1)
        tst.b   rl_avl(a2)
        bpl.s   RL_2
        move.b  #1,rl_avl(a0)
RL_2
        move.l  p.ptr(sp),a1    ; get value for p
        move.l  a2,(a1)         ; p=p2
        clr.b   rl_avl(a2)      ; in balance p^bal=0 (p=p2)
        moveq   #0,d2           ; no growth
        move.l  a5,a2           ; restore a2
        rts

;
        end
