; insert array elements
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
        include dev8_k
        include dev8_ext_thg
*
; insert array elements
; inserted elements will be cleared to zero
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; id of field (call uword, opt, nnul)
p.place equ     $c      ; place to insert before
p.nr    equ     $10     ; nr of elements to insert
; errors
; itnf  buffer id invalid
; ipar  fieldid doesn't exist
; orng  place has to be >=1
;       nr has to be >=1
; imem  insufficient memory
; rdo   read only buffer
cod_INSE xsub
        regsave d1/d2/d5-d7/a1/a3-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error

        ; we need a read/write buffer
        moveq   #err.rdo,d0
        tst.b   b_view(a4)
        bne     codend

        move.w  p.fld+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2
        move.l  b_file(a4),a3   ; we need fileid

        ; now find out the field type
        moveq   #err.ipar,d0    ; assume fieldid doesn't exist
        move.l  d2,d1
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        tst.w   (a3)            ; does this field exist ?
        beq.s   codend          ; no it doesn't

        ; check line to fill it in
        moveq   #err.orng,d0    ; assume not
        move.l  p.place(a5),d7  ; place to insert
        ble.s   codend
        subq.l  #1,d7           ; we want to insert AFTER
        move.l  p.nr(a5),d6     ; nr of elements to insert
        ble.s   codend

        ; expand d6/d7 to actual nr of bytes
        cmpi.b  #ft.char,(a3)   ; byte oriented
        ble.s   exp
        add.l   d6,d6           ; make it word oriented
        ble.s   codend
        add.l   d7,d7
        ble.s   codend
        cmpi.b  #ft.short,(a3)  ; word oriented ?
        ble.s   exp
        add.l   d6,d6           ; make it long oriented
        ble.s   codend
        add.l   d7,d7
        ble.s   codend
        cmpi.b  #ft.long,(a3)   ; word oriented ?
        ble.s   exp
        add.l   d6,d6           ; make it double oriented
        ble.s   codend
        add.l   d7,d7
        ble.s   codend
exp
        ; something will have changed
        move.b  #1,b_change(a4)

        ; so try to find this field
        move.l  b_mem(a4),a1    ; start of record
        move.l  b_rlen(a4),d1   ; recordlen
        xjsr    findfld         ; find it
        beq.s   old             ; overwrite old field -> ..

        ; ok, we have to create a new field for this one
        ; create the field
        move.l  d7,d1           ; place
        add.l   d6,d1           ; add length to insert
        xjsr    newfld          ; create it
        bne.s   codend          ; oops ...

        ; now clear the field
        lea     rf_fld(a1),a1
loop    clr.b   (a1)+           ; clear it
        subq.l  #1,d1           ; another one ?
        bgt     loop
codend  subend

old     ; see if we can fit it in the field
        cmp.l   rf_len(a1),d7   ; do we have to append
        blt.s   insert          ; no -> actual inserting

        move.l  rf_len(a1),d5   ; we will need this later
        move.l  d6,d1
        add.l   d7,d1           ; total len of field
        sub.l   d5,d1           ; take increment
        xjsr    incrfld
        bne     codend

        ; now clear what we added
        lea     rf_fld(a1,d5.l),a1      ; start of area to clear
        bra     loop            ; clear it

insert  ; we really have to insert
        move.l  rf_len(a1),d5   ; previous field len
        sub.l   d7,d5           ; nr of bytes at end to copy
        move.l  d6,d1
        xjsr    incrfld         ; increase the field len
        bne     codend

        lea     rf_fld(a1,d5.l),a1      ; end of area to copy
        adda.l  d7,a1           ; we need the end of the area to copy
loop2   move.b  -(a1),0(a1,d6.l)
        subq.l  #1,d5
        bgt     loop2
        bra     loop            ; and now clear the area
;
        end
