; get the field length
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; get the field length, i.e. the nr of elements in the field
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; fieldid (uword)
p.ret   equ     $10     ; return value (ulong)
; errors
; itnf  buffer id invalid
;       or field not found
cod_LENF xsub
        regsave d1/d2/d7/a1/a3/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.w  p.fld+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2         ; make sure it is word long

        ; now find out the field type
        move.l  b_file(a4),a3   ; fileid
        move.w  d2,d1
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        move.b  (a3),d7         ; fieldtype

        move.l  b_mem(a4),a1
        move.l  b_rlen(a4),d1
        xjsr    findfld         ; find field
        bne.s   codend
        move.l  rf_len(a1),d2   ; field len
        beq.s   done

        cmpi.b  #ft.short,d7    ; is it a short
        blt.s   done            ; no -> byte sized
        lsr.l   #1,d2
        cmpi.b  #ft.long,d7     ; is it a long
        blt.s   done            ; no -> word sized
        lsr.l   #1,d2
        cmpi.b  #ft.ieee,d7     ; is it a double
        blt.s   done            ; no -> long sized
        lsr.l   #1,d2

done    move.l  p.ret(a5),a1    ; place to fill in return value
        move.l  d2,(a1)         ; fillin
codend
        subend
;
        end
