; routine to create a new file and return the buffer to it
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_ext_thg
        include dev8_qdos_sms
        include dev8_err
*
; create a new file and return the bufferid to access it with this job
; also sets the default buffer
; parameters
p.name  equ     $4      ; name of file (string or substring, optional)
p.ret   equ     $c      ; return buffer id
; errors
; omem  out of memory
cod_NEWF xsub
        regsave d1/a1/a2/a5
        move.l  a1,a5           ; keep ptr to parameter list in a safe place

        bsr.s   newfile         ; create a new file and buffer (buffer id returned in d0)
        bmi.s   codend          ; error -> forget it all

        ; fill in return value
        move.l  p.ret(a5),a1    ; place to fill in return value
        move.l  d0,(a1)         ; fill it in

        ; now all we have to do is fill in the file name
        move.l  d0,a2           ; bufferid
        move.l  b_file(a2),a2   ; fileid
        lea     f_name(a2),a2   ; place to fill in file-name
        moveq   #0,d0           ; clear error for return
        move.w  p.name-4(a5),d1 ; type of parameter
        beq.s   codend          ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   codnstr         ; no -> ..
        move.l  p.name(a5),a1   ; ptr to name
        move.w  (a1)+,d1        ; string length
        beq.s   codend          ; if zero -> no string to copy
        bra.s   codcps          ; copy string
codnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   codend
        move.w  p.name-2(a5),d1 ; string length
        beq.s   codend          ; if zero -> no string to copy
        move.l  p.name(a5),a1   ; ptr to name
codcps
        cmp.w   #32,d1          ; check that name is not too long
        bmi.s   codlok          ; not too long
        move.w  #32,d1          ; name max 32 chars
codlok  move.w  d1,(a2)+        ; fill in length
        subq.w  #1,d1           ; prepare for dbf
codcpy  move.b  (a1)+,(a2)+     ; copy a char
        dbf     d1,codcpy       ; and the next one ?...
codend
        subend

; routine which actually creates a new file, returns buffer id in d0, or error code
newfile xsub
        regsave d1/d2/a0-a3
s.file  equ     0       ; file id
s.buff  equ     4       ; buffer id
s.len   equ     8
        getssp  s.len

        move.l  #f.len,d1       ; length of file linkage
        xjsr    getmem          ; get the memory for it (cleared)
        bne     newend
        move.l  a0,s.file(sp)   ; keep it
        ; set flag
        move.l  #'DATA',f_flag(a0)
        move.l  #'desi',f_flag+4(a0)
        move.l  #'gn f',f_flag+8(a0)
        move.l  #'ile ',f_flag+12(a0)

        move.l  #b.len,d1       ; length of buffer linkage
        xjsr    getmem          ; get the memory for it (cleared)
        bne     relfile
        move.l  a0,s.buff(sp)   ; keep it
        ; set flag
        move.l  #'DATA',b_flag(a0)
        move.l  #'desi',b_flag+4(a0)
        move.l  #'gn b',b_flag+8(a0)
        move.l  #'uffr',b_flag+12(a0)

        move.l  #1024,d1        ; length of actual buffer
        xjsr    getmem          ; get the memory for it (d1 is length allocated)
        bne     relbuff

        move.l  s.buff(sp),a1   ; ptr to buffer
        move.l  s.file(sp),a2   ; ptr to file
        move.l  d1,b_mlen(a1)   ; fill in length of buffer memory
        move.l  a0,b_mem(a1)    ; ptr to buffer memory
        move.b  #1,b_new(a1)    ; we will start with a new record
        moveq   #sms.info,d0
        trap    #do.sms2        ; job id returned in d1
        move.l  d1,b_jobid(a1)
        move.l  a1,f_buffer(a2) ; fill in ptr to buffers using this file
        move.l  a2,b_file(a1)   ; ptr to file this buffer uses
        lea     f_fields(a2),a3 ; start of fields description
        move.b  #ft.text,(a3)+  ; text field
        move.b  #4,(a3)+        ; field name length = 4
        move.l  #'MEMO',(a3)+   ; always a memo field in the record with fieldid = 0

        moveq   #127,d0         ; nr of long words to copy
        lea     order(pc),a0
        lea     f_order1(a2),a3
cpordr  move.l  (a0)+,(a3)+
        dbf     d0,cpordr
                                ; now also build the case independant one
        moveq   #127,d0         ; nr of long words to copy
        lea     f_order1(a2),a0
        lea     f_order3(a2),a3
cpordr1 move.l  (a0)+,(a3)+
        dbf     d0,cpordr1
        moveq   #25,d0
        lea     f_order3+65(a2),a0
        lea     f_order3+97(a2),a3
cpordr2 move.b  (a0)+,(a3)+
        dbf     d0,cpordr2
        moveq   #25,d0
        lea     f_order4+65(a2),a0
        lea     f_order4+97(a2),a3
cpordr3 move.b  (a0)+,(a3)+
        dbf     d0,cpordr3

        move.l  a2,d0           ; new file id
        xjsr    linkfid         ; link it in
        move.l  a1,d0           ; new buffer id
        xjsr    setbuff         ; make it default
newend
        subend
relfile                         ; release file mem
        move.l  d0,d1           ; keep error code for a while
        move.l  s.file(sp),a0
        xjsr    relmem          ; release file
        move.l  d1,d0
        bra.s   newend
relbuff                         ; release buffer & file mem
        move.l  d0,d1           ; keep error code for a while
        move.l  s.file(sp),a0
        xjsr    relmem          ; release file
        move.l  s.buff(sp),a0
        xjsr    relmem          ; release buffer
        move.l  d1,d0
        bra.s   newend
;
; default sort order for a field
; AaBbCcDdEeFfGgHhIiJjKkLlMmNnOoPpQqRrSsTtUuVvWwXxYyZz0123456789 ,.
; all other printable characters in chr$ order
; chr$(192) - chr$ (255)
; chr$(0) - chr$ (31)
order   dc.b    $e0,$e1,$e2,$e3,$e4,$e5,$e6,$e7,$e8,$e9,$ea,$eb,$ec,$ed,$ee,$ef         0  - 15
        dc.b    $f0,$f1,$f2,$f3,$f4,$f5,$f6,$f7,$f8,$f9,$fa,$fb,$fc,$fd,$fe,$ff         16 - 31

        dc.b    $66,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71,$72,$73,$67,$74,$68,$75
        dc.b    $5C,$5D,$5E,$5F,$60,$61,$62,$63,$64,$65,$76,$77,$78,$79,$7A,$7B
        dc.b    $7C,$00,$08,$0A,$0E,$10,$17,$19,$1B,$1D,$23,$25,$27,$29,$2B,$2F
        dc.b    $38,$3A,$3C,$3E,$41,$43,$4A,$4C,$4E,$50,$52,$7D,$7E,$7F,$80,$81
        dc.b    $82,$03,$09,$0C,$0F,$12,$18,$1A,$1C,$1E,$24,$26,$28,$2A,$2D,$32
        dc.b    $39,$3B,$3D,$3F,$42,$45,$4B,$4D,$4F,$51,$53,$83,$84,$85,$86,$87
        dc.b    $88,$04,$59,$14,$33,$34,$57,$46,$0D,$2E,$55,$5B,$05,$06,$07,$13
        dc.b    $15,$16,$1F,$20,$21,$22,$35,$36,$37,$47,$48,$49,$40,$89,$8A,$8B
        dc.b    $01,$02,$58,$11,$30,$31,$56,$44,$0B,$2C,$54,$5A,$8C,$8D,$8E,$8F
        dc.b    $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F

        dc.b    $a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af         192-
        dc.b    $b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$ba,$bb,$bc,$bd,$be,$bf         208-
        dc.b    $c0,$c1,$c2,$c3,$c4,$c5,$c6,$c7,$c8,$c9,$ca,$cb,$cc,$cd,$ce,$cf         224-
        dc.b    $d0,$d1,$d2,$d3,$d4,$d5,$d6,$d7,$d8,$d9,$da,$db,$dc,$dd,$de,$df         240-255
        ; inverse order
        ; ZzYyXxWwVvUuTtSsRrQqPpOoNnMmLlKkJjIiHhGgFfEeDdCcBbAa9876543210 ,.
        ; other chars, same order as normal order
        dc.b    $e0,$e1,$e2,$e3,$e4,$e5,$e6,$e7,$e8,$e9,$ea,$eb,$ec,$ed,$ee,$ef         0  - 15
        dc.b    $f0,$f1,$f2,$f3,$f4,$f5,$f6,$f7,$f8,$f9,$fa,$fb,$fc,$fd,$fe,$ff         16 - 31

        dc.b    $66,$69,$6A,$6B,$6C,$6D,$6E,$6F,$70,$71,$72,$73,$67,$74,$68,$75
        dc.b    $65,$64,$63,$62,$61,$60,$5F,$5E,$5D,$5C,$76,$77,$78,$79,$7A,$7B
        dc.b    $7C,$4C,$4A,$46,$44,$3D,$3B,$39,$37,$31,$2F,$2D,$2B,$29,$25,$1C
        dc.b    $1A,$18,$16,$13,$11,$0A,$08,$06,$04,$02,$00,$7D,$7E,$7F,$80,$81
        dc.b    $82,$4F,$4B,$48,$45,$3F,$3C,$3A,$38,$32,$30,$2E,$2C,$2A,$27,$1F
        dc.b    $1B,$19,$17,$14,$12,$0C,$09,$07,$05,$03,$01,$83,$84,$85,$86,$87
        dc.b    $88,$50,$59,$41,$20,$21,$57,$0D,$49,$28,$55,$5B,$51,$52,$53,$40
        dc.b    $42,$43,$33,$34,$35,$36,$22,$23,$24,$0E,$0F,$10,$15,$89,$8A,$8B
        dc.b    $4D,$4E,$58,$3E,$1D,$1E,$56,$0B,$47,$26,$54,$5A,$8C,$8D,$8E,$8F
        dc.b    $90,$91,$92,$93,$94,$95,$96,$97,$98,$99,$9A,$9B,$9C,$9D,$9E,$9F

        dc.b    $a0,$a1,$a2,$a3,$a4,$a5,$a6,$a7,$a8,$a9,$aa,$ab,$ac,$ad,$ae,$af         192-
        dc.b    $b0,$b1,$b2,$b3,$b4,$b5,$b6,$b7,$b8,$b9,$ba,$bb,$bc,$bd,$be,$bf         208-
        dc.b    $c0,$c1,$c2,$c3,$c4,$c5,$c6,$c7,$c8,$c9,$ca,$cb,$cc,$cd,$ce,$cf         224-
        dc.b    $d0,$d1,$d2,$d3,$d4,$d5,$d6,$d7,$d8,$d9,$da,$db,$dc,$dd,$de,$df         240-255
;
        end
