; get the nr of lines in the field
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
        include dev8_k
*
; get the nr of lines in the field
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fld   equ     $8      ; fieldid (uword, opt, nnul)
p.ret   equ     $10     ; return value (ulong)
; errors
; itnf  buffer id invalid
;       or field not found
; ipar  field doesn't exist
;       or has wrong type
cod_NRLN xsub
        regsave d1/d2/a1/a3/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.w  p.fld+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2         ; make sure it is word long
        move.l  b_file(a4),a3   ; we need fileid

        ; now find out the field type
        moveq   #err.ipar,d0    ; assume fieldid doesn't exist
        move.w  d2,d1           ; fieldid
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        tst.w   (a3)            ; does this field exist ?
        beq.s   codend          ; no it doesn't
        ; fieldtype ok ?
        cmpi.b  #ft.text,(a3)
        bne.s   codend

        move.l  b_mem(a4),a1
        move.l  b_rlen(a4),d1
        xjsr    findfld         ; find field
        bne.s   codend
        move.l  rf_len(a1),d2   ; field len
        moveq   #1,d1           ; there is at least one line
        lea     rf_fld(a1),a1   ; actaul start of field
        bra.s   next
loop    cmpi.b  #k.nl,(a1)+     ; a newline ??
        bne.s   next
        addq.l  #1,d1
next    subq.l  #1,d2           ; test another byte
        bpl.s   loop

        move.l  p.ret(a5),a1    ; place to fill in return value
        move.l  d1,(a1)         ; fillin
codend
        subend
;
        end
