; save the file to a device, or backup
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
        include dev8_qdos_sms
        include dev8_qdos_ioa
        include dev8_sys
        include dev8_ext_thg
*
; save the file to a device
; the (THIS) buffer is implemented first
; it doesn't do anything if the file is medium-based
; filename and device are changed if passed
; if device not passed, and no default -> DATAD$ used if just calling the filename doesn't work
; this routines also takes the IRS into account
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.name  equ     $c      ; name of file (opt, string or substring)
p.dev   equ     $14     ; device of file (opt, string or substring)
p.over  equ     $18     ; overwrite file ? (uword, 0-> no overwrite)
; errors
; rdo   oops, read only medium, and no overwrite
; drfl  drive full
; fex   file already exists
; ...
; any other file-error
cod_SAVE xsub
        regsave d1-d7/a0-a5
        xjsr    cod_IMPL        ; first implement THIS buffer
        bne     codend

        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error

        move.l  b_file(a4),a3   ; set fileid which this buffer uses
        tst.b   f_file(a3)      ; is it file based ??
        bne     codend          ; yes -> yahoe, we don't have to work

        ; now we copy the filename
        lea     f_name(a3),a2   ; place to fill in file-name
        moveq   #0,d0           ; clear error for return
        move.w  p.name-4(a5),d1 ; type of parameter
        beq.s   enam            ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   codnstr         ; no -> ..
        move.l  p.name(a5),a1   ; ptr to name
        move.w  (a1)+,d1        ; string length
        beq.s   enam            ; if zero -> no string to copy
        bra.s   codcps          ; copy string
codnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   enam
        move.w  p.name-2(a5),d1 ; string length
        beq.s   enam            ; if zero -> no string to copy
        move.l  p.name(a5),a1   ; ptr to name
codcps
        cmp.w   #32,d1          ; check that name is not too long
        bmi.s   codlok          ; not too long
        move.w  #32,d1          ; name max 32 chars
codlok  move.w  d1,(a2)+        ; fill in length
        subq.w  #1,d1           ; prepare for dbf
codcpy  move.b  (a1)+,(a2)+     ; copy a char
        dbf     d1,codcpy       ; and the next one ?...
enam
        ; now we copy the devicename
        lea     f_device(a3),a2 ; place to fill in file-name
        moveq   #0,d0           ; clear error for return
        move.w  p.dev-4(a5),d1  ; type of parameter
        beq.s   edev            ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   ccdnstr         ; no -> ..
        move.l  p.dev(a5),a1    ; ptr to name
        move.w  (a1)+,d1        ; string length
        beq.s   edev            ; if zero -> no string to copy
        bra.s   ccdcps          ; copy string
ccdnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   edev
        move.w  p.dev-2(a5),d1  ; string length
        beq.s   edev            ; if zero -> no string to copy
        move.l  p.dev(a5),a1    ; ptr to name
ccdcps
        cmp.w   #32,d1          ; check that name is not too long
        bmi.s   ccdlok          ; not too long
        move.w  #32,d1          ; name max 32 chars
ccdlok  move.w  d1,(a2)+        ; fill in length
        subq.w  #1,d1           ; prepare for dbf
ccdcpy  move.b  (a1)+,(a2)+     ; copy a char
        dbf     d1,ccdcpy       ; and the next one ?...
edev

        mutex                   ; enter supervisor mode, prevent stack from moving about
        suba.w  #70,sp          ; reserve area for filename
openlp
        bsr     gnam
        moveq   #myself,d1
        moveq   #ioa.knew,d3    ; new file
        tst.b   p.over+3(a5)    ; overwrite ?
        beq.s   nover           ; no -> ...
        moveq   #ioa.kovr,d3
nover   moveq   #ioa.open,d0
        trap    #do.ioa         ; open the file
        cmpi.l  #err.fdnf,d0    ; let's see if we can add DATAD$
        bne.s   opened
        ; ok, can we fill in DATAD$ as device ??
        tst.w   f_device(a3)    ; is there already a device
        bne.s   opened          ; well, forget it
        ; so get the data device, and fill it in
        moveq   #sms.info,d0    ; get system information
        trap    #do.sms2
        move.l  sys_datd(a0),a1 ; DATA_USE device in a1
        lea     f_device(a3),a0
        moveq   #err.fdnf,d0    ; restore error just in case
        move.w  (a1)+,d1        ; length
        move.w  d1,(a0)+
        beq     ahum
        subq.w  #1,d1           ; prepare for dbf
gfdat   move.b  (a1)+,(a0)+     ; copy a char
        dbf     d1,gfdat        ; and the next one ?...
        ; try opening again
        bra     openlp
opened  tst.l   d0              ; was there an error ??
        bmi     ahum            ; you must be kidding
        ; when we get here, the file is opened and the chid is in d0

        ; start building the file data
        move.l  sp,a1
        move.l  #'DATA',(a1)+
        move.l  #'desi',(a1)+
        move.l  #'gn f',(a1)+
        move.l  #'ile ',(a1)+
        move.w  #'00',(a1)+
        move.l  f_lstrid(a3),(a1)+
        move.b  f_lstfid(a3),(a1)+
        move.b  f_file(a3),(a1)+
        move.w  f_irsp(a3),(a1)+
        move.l  sp,a1           ; header to send
        moveq   #26,d2          ; nr of bytes to send
        xjsr    iob_smul
        bmi     clos            ; oops...
        lea     f_order1(a3),a1
        move.l  #512,d2         ; standard sort order
        xjsr    iob_smul
        bmi.s   clos
        lea     f_fields(a3),a1
        move.l  #4608,d2        ; fielddata
        xjsr    iob_smul
        bmi.s   clos

        ; and now start writing all the records to the file
        ; we do this by running through all areas and saving all records which we found
        ; this is a recordlinkage with recordid <>-1
        move.l  f_area(a3),d1   ; place in list of areas
        beq.s   clos            ; no records to save -> ..
arealp  move.l  d1,a5
        moveq   #99,d7          ; nr of linkages to run through
        lea     4(a5),a4        ; first record linkage
nxtrl   cmpi.l  #-1,rl_id(a4)   ; linkage used ??
        beq.s   endrl

        ; save the IRS
        move.w  f_irsp(a3),d6   ; save inter record space
        subq.w  #1,d6           ; prepare for dbf
        bmi.s   endirs          ; if there is some irs
irslp   moveq   #0,d1           ; bytes to send
        xjsr    iob_sbyt
        bmi.s   clos
        dbf     d6,irslp
endirs  ; now send the actual record
        ; first a header
        move.l  sp,a1           ; start of buffer
        move.l  rl_pos(a4),a2   ; actual record
        move.b  #'R',(a1)+      ; byte to send
        move.b  r_mark(a2),(a1)+
        move.l  r_id(a2),(a1)+
        move.l  r_date(a2),(a1)+
        move.l  r_len(a2),(a1)+
        move.l  sp,a1           ; start of buffer
        moveq   #14,d2          ; nr of bytes to send
        xjsr    iob_smul
        bmi.s   clos
        ; now the record contents
        move.l  r_len(a2),d2    ; record len
        lea     r_fld(a2),a1    ; buffer start
        xjsr    iob_smul
        bmi.s   clos

endrl   adda.w  #rl.len,a4      ; start of next linkage
        dbf     d7,nxtrl

        move.l  (a5),d1         ; next area ??
        bne     arealp          ; if there is one

clos    ; now close this channel
        move.l  d0,d7
        moveq   #ioa.clos,d0
        trap    #do.ioa
        move.l  d7,d0

ahum    adda.w  #70,sp          ; release ssp
        endmutex                ; hehe, all done
codend  subend
;

; routine to build the filename on stack (start addr returned in a0)
gnam    xsub    ; build medium-filename
        lea     4(sp),a0        ; and put it in a0
        lea     f_device(a3),a1 ; start of device
        move.w  (a1)+,d1        ; length
        move.w  d1,(a0)+
        beq.s   ndev
        subq.w  #1,d1           ; prepare for dbf
gfdev   move.b  (a1)+,(a0)+     ; copy a char
        dbf     d1,gfdev        ; and the next one ?...
ndev    lea     4(sp),a2
        lea     f_name(a3),a1   ; start of device
        move.w  (a1)+,d1        ; length
        beq.s   nnam
        add.w   d1,(a2)+
        subq.w  #1,d1           ; prepare for dbf
gfnam   move.b  (a1)+,(a0)+     ; copy a char
        dbf     d1,gfnam        ; and the next one ?...
nnam    ; now see if we have to add _ddf
        cmpi.b  #'_',-4(a0)     ; is there a _ddf
        bne.s   add_ddf
        cmpi.b  #'d',-3(a0)
        beq.s   ext3
        cmpi.b  #'D',-3(a0)
        bne.s   add_ddf
ext3    cmpi.b  #'d',-2(a0)
        beq.s   ext4
        cmpi.b  #'D',-2(a0)
        bne.s   add_ddf
ext4    cmpi.b  #'f',-1(a0)
        beq.s   open
        cmpi.b  #'F',-1(a0)
        beq.s   open
add_ddf move.b  #'_',(a0)+      ; add _ddf to the filename
        move.b  #'d',(a0)+
        move.b  #'d',(a0)+
        move.b  #'f',(a0)+
        lea     4(sp),a0
        add.w   #4,(a0)
open    lea     4(sp),a0        ; start of filename
        rts
;
        end
