; routine to set the contents of an entire field
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; set the contents of an entire field
; the fieldtype is not considered
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.fid   equ     $8      ; fieldid (uword)
p.len   equ     $c      ; length of new field (ulong)
p.place equ     $14     ; ptr to place with new contents (ptr, has to be passed, doesn't have to be even)
; errors
; itnf  invalid bufferid
; ipar  invalid field id
; imem  out of memory (old situation is preserved)
; rdo   read only buffer
cod_SFLD xsub
        regsave d1/d2/a1-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        moveq   #err.rdo,d0     ; assume we can only read this one
        tst.b   b_view(a4)      ; can we write
        bne.s   codend          ; no -> ...

        move.w  p.fid+2(a5),d2  ; field id
        bpl.s   notdef          ; no, we don't need the default
        move.b  b_dfield(a4),d2 ; default field
notdef  andi.w  #255,d2
        move.l  b_file(a4),a3   ; we need fileid

        ; check if field exists !!
        moveq   #err.ipar,d0    ; assume fieldid doesn't exist
        move.w  d2,d1
        mulu    #18,d1          ; start of field
        add.w   #f_fields,d1    ; offset in filedata
        lea     0(a3,d1.w),a3   ; start of field
        tst.w   (a3)            ; does this field exist ?
        beq.s   codend          ; no it doesn't

        move.l  b_mem(a4),a1    ; start of record
        move.l  b_rlen(a4),d1   ; recordlen
        xjsr    findfld         ; find it
        beq.s   old             ; overwrite old field -> ..

        ; create the field
        move.l  p.len(a5),d1    ; field length
        xjsr    newfld          ; create it
        bne.s   codend          ; oops ...
        bra.s   fillit

old     ; now overwrite the old field
        move.l  p.len(a5),d1    ; field length
        sub.l   rf_len(a1),d1   ; minus old length gives increment
        xjsr    incrfld         ; increase field length
        bne.s   codend          ; oops ...
fillit
        lea     rf_fld(a1),a1   ; start of field
        move.l  p.place(a5),a2  ; start of new contents
        move.l  p.len(a5),d1    ; length
        subq.l  #1,d1           ; make sure we don't copy a word too much
loop    move.b  (a2)+,(a1)+     ; copy a byte
        subq.l  #1,d1           ; another one ?
        bpl     loop
codend
        subend
;
        end
