; save record sequence initialise/do/finish
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
        include dev8_qdos_sms
        include dev8_qdos_ioa
        include dev8_qdos_io
        include dev8_sys
        include dev8_ext_thg
*
; save record sequence initialise
; each buffer can only use one save sequence simultaneously
; if device not passed, and no default -> DATAD$ used if just calling the filename doesn't work
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.name  equ     $c      ; name of file (opt, string or substring)
p.dev   equ     $14     ; device of file (opt, string or substring)
p.over  equ     $18     ; overwrite file ? (uword, 0-> no overwrite)
; errors
; itnf  bufferid invalid
; rdo   oops, read only medium, and no overwrite
; fex   file already exists
; fdiu  in use, there is still a channel open, should call SAVF
; ...
; any other file-error
cod_SAVI xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   ibuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
ibuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error

        moveq   #err.fdiu,d0    ; assume in use
        tst.l   b_chid(a4)      ; test it
        bne     codend          ; oops

        ; now take filename
        move.w  p.name-4(a5),d1 ; type of parameter
        beq.s   enam            ; not specified -> don't copy
        btst    #thp..str,d1    ; string parameter ?
        beq.s   codnstr         ; no -> ..
        move.l  p.name(a5),a1   ; ptr to name
        move.w  (a1)+,d1        ; string length
        beq.s   enam            ; if zero -> no string to copy
        bra.s   codcps          ; copy string
codnstr btst    #thp..sst,d1    ; sub-string parameter ?
        beq.s   enam
        move.w  p.name-2(a5),d1 ; string length
        beq.s   enam            ; if zero -> no string to copy
        move.l  p.name(a5),a1   ; ptr to name
codcps
        cmp.w   #32,d1          ; check that name is not too long
        bmi.s   enam            ; not too long
        move.w  #32,d1          ; name max 32 chars
enam
        ; now take devicename
        move.w  p.dev-4(a5),d2  ; type of parameter
        beq.s   edev            ; not specified -> don't copy
        btst    #thp..str,d2    ; string parameter ?
        beq.s   ccdnstr         ; no -> ..
        move.l  p.dev(a5),a2    ; ptr to name
        move.w  (a2)+,d2        ; string length
        beq.s   edev            ; if zero -> no string to copy
        bra.s   ccdcps          ; copy string
ccdnstr btst    #thp..sst,d2    ; sub-string parameter ?
        beq.s   edev
        move.w  p.dev-2(a5),d2  ; string length
        beq.s   edev            ; if zero -> no string to copy
        move.l  p.dev(a5),a2    ; ptr to name
ccdcps
        cmp.w   #32,d2          ; check that name is not too long
        bmi.s   edev            ; not too long
        moveq   #32,d2          ; name max 32 chars
edev
        mutex                   ; enter supervisor mode, prevent stack from moving about
        suba.w  #70,sp          ; reserve area for filename
openlp
        bsr     gnam            ; build filename
        movem.l d1/a1,-(sp)
        moveq   #myself,d1
        moveq   #ioa.knew,d3    ; new file
        tst.b   p.over+3(a5)    ; overwrite ?
        beq.s   nover           ; no -> ...
        moveq   #ioa.kovr,d3
nover   moveq   #ioa.open,d0
        trap    #do.ioa         ; open the file
        movem.l (sp)+,d1/a1
        cmpi.l  #err.fdnf,d0    ; let's see if we can add DATAD$
        bne.s   opened
        ; ok, can we fill in DATAD$ as device ??
        tst.w   d2              ; is there already a device
        bne.s   opened          ; well, forget it
        ; so get the data device, and fill it in
        move.l  d1,d3
        moveq   #sms.info,d0    ; get system information
        trap    #do.sms2
        move.l  d3,d1
        move.l  sys_datd(a0),a2 ; DATA_USE device in a1
        moveq   #err.fdnf,d0    ; restore error just in case
        move.w  (a2)+,d2        ; len of device
        beq.s   ahum
        ; try opening again
        bra     openlp
opened  tst.l   d0              ; was there an error ??
        bmi.s   ahum            ; you must be kidding
        ; when we get here, the file is opened and the chid is in d0
        move.l  a0,b_chid(a4)   ; save the channel id
        move.l  b_file(a4),a3   ; we need the fileid

        ; start building the file data
        move.l  sp,a1
        move.l  #'DATA',(a1)+
        move.l  #'desi',(a1)+
        move.l  #'gn f',(a1)+
        move.l  #'ile ',(a1)+
        move.w  #'00',(a1)+
        move.l  f_lstrid(a3),(a1)+
        move.b  f_lstfid(a3),(a1)+
        move.b  f_file(a3),(a1)+
        move.w  f_irsp(a3),(a1)+
        move.l  sp,a1           ; header to send
        moveq   #26,d2          ; nr of bytes to send
        xjsr    iob_smul
        bmi.s   clos            ; oops...
        lea     f_order1(a3),a1
        move.l  #512,d2         ; standard sort order
        xjsr    iob_smul
        bmi.s   clos
        lea     f_fields(a3),a1
        move.l  #4608,d2        ; fielddata
        xjsr    iob_smul
        beq.s   ahum

clos    ; now close this channel
        move.l  d0,d7
        moveq   #ioa.clos,d0
        trap    #do.ioa
        move.l  d7,d0
        clr.l   b_chid(a0)      ; no channel open

ahum    adda.w  #70,sp          ; release ssp
        endmutex                ; hehe, all done
codend  subend
*
; save record
; the record has to have been implemented once (has to have a recordid)
; each record should only be saved once (or problems when loading)
; if device not passed, and no default -> DATAD$ used if just calling the filename doesn't work
; this routines also takes the IRS into account
; when an error has occured. the channel should be closed (SAVF)
; parameters
;p.id    equ     $4      ; buffer id (long word, optional)
; errors
; itnf  bufferid invalid
; drfl  drive full
; orng  this is a new record, not accepted
; ...
; any other file-error
cod_SAVR xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   rbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
rbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error

        moveq   #err.orng,d0    ; assume problem
        tst.b   b_new(a4)       ; is this a new record
        bne     codend          ; hey -> no new records accepted

        move.l  b_file(a4),a3   ; we also need the fileid
        move.l  b_chid(a4),a0   ; and the channel id

        ; save the IRS
        move.w  f_irsp(a3),d6   ; save inter record space
        subq.w  #1,d6           ; prepare for dbf
        bmi.s   endirs          ; if there is some irs
irslp   moveq   #0,d1           ; byte to send
        moveq   #forever,d3     ; timeout
        moveq   #iob.sbyt,d0    ; send a byte
        trap    #do.io
        tst.l   d0
        bmi     codend
        dbf     d6,irslp
endirs  ; now send the actual record
        ; first a header
        mutex
        lea     -30(sp),sp      ; we need a small buffer
        move.l  b_id(a4),d1     ; find record linkage
        xjsr    findrec
        move.l  rl_pos(a1),a2   ; actual record
        move.l  sp,a1           ; start of buffer
        move.b  #'R',(a1)+      ; byte to send
        move.b  b_mark(a4),(a1)+
        move.l  r_id(a2),(a1)+
        move.l  r_date(a2),(a1)+
        move.l  b_rlen(a4),(a1)+
        move.l  sp,a1           ; start of buffer
        moveq   #14,d2          ; nr of bytes to send
        xjsr    iob_smul
        lea     30(sp),sp       ; clean up stack
        endmutex
        tst.l   d0
        bmi     codend
        ; now the record contents
        move.l  b_rlen(a4),d2   ; record len
        move.l  b_mem(a4),a1    ; buffer start
        moveq   #forever,d3     ; timeout
        moveq   #iob.smul,d0    ; send multiple bytes
        trap    #do.io
        bra     codend          ; done

; routine to build the filename on stack (start addr returned in a0)
gnam    subr    ; build medium-filename
        lea     4(sp),a0        ; and put it in a0
        move.w  d2,(a0)+
        beq.s   ndev
        move.l  a2,a3
        move.w  d2,d3
        subq.w  #1,d3           ; prepare for dbf
gfdev   move.b  (a3)+,(a0)+     ; copy a char
        dbf     d3,gfdev        ; and the next one ?...
ndev    lea     4(sp),a3
        add.w   d1,(a3)
        move.w  d1,d3
        beq.s   nnam
        move.l  a1,a3
        subq.w  #1,d3           ; prepare for dbf
gfnam   move.b  (a3)+,(a0)+     ; copy a char
        dbf     d3,gfnam        ; and the next one ?...
nnam    ; now see if we have to add _ddf
        cmpi.b  #'_',-4(a0)     ; is there a _ddf
        bne.s   add_ddf
        cmpi.b  #'d',-3(a0)
        beq.s   ext3
        cmpi.b  #'D',-3(a0)
        bne.s   add_ddf
ext3    cmpi.b  #'d',-2(a0)
        beq.s   ext4
        cmpi.b  #'D',-2(a0)
        bne.s   add_ddf
ext4    cmpi.b  #'f',-1(a0)
        beq.s   open
        cmpi.b  #'F',-1(a0)
        beq.s   open
add_ddf move.b  #'_',(a0)+      ; add _ddf to the filename
        move.b  #'d',(a0)+
        move.b  #'d',(a0)+
        move.b  #'f',(a0)+
        lea     4(sp),a0
        add.w   #4,(a0)
open    lea     4(sp),a0        ; start of filename
        rts
*
; save record sequence finish
; parameters
;p.id    equ     $4      ; buffer id (long word, optional)
; errors
; itnf  bufferid invalid
cod_SAVF xsub
        regsave d1-d7/a0-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   fbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
fbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne     codend          ; if not -> error

        tst.l   b_chid(a4)      ; is there a channel to close ??
        beq     codend          ; no -> oops
        move.l  b_chid(a4),a0   ; channel to close
        moveq   #ioa.clos,d0    ; close channel
        trap    #do.ioa
        clr.l   b_chid(a4)      ; not used any more
        bra     codend
;
        end
