; get/set index filter/sort level parameters
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; get/set index filter/sort level parameters
; get index sort level parameters
; parameters
p.id    equ     $4      ; buffer id or indexid (long word, optional)
p.lvl   equ     $8      ; sort level (uword)
p.cmp   equ     $10     ; ptr to compare (uword, will be updated)
p.fld   equ     $18     ; ptr to field (uword, will be updated)
p.plc   equ     $20     ; ptr to place in field (uword, will be updated)
p.val   equ     $28     ; ptr to value (8.b, will be updated, filter only)
; errors
; itnf  invalid buffer or indexid
; orng  not 1<=level<=10
cod_GISL xsub

regs    reg     d1/a0-a2/a4/a5
        regsave regs
        lea     gisl(pc),a0
        bra     doit
gisl    mulu    #i.slen,d1      ; get offset in list
        lea     i_sort-i.slen(a2,d1.w),a0
        move.l  p.cmp(a5),a1    ; place for level
        move.w  i_cmp(a0),(a1)
        move.l  p.fld(a5),a1    ; place for field
        clr.b   (a1)
        move.b  i_fld(a0),1(a1)
        move.l  p.plc(a5),a1    ; place for place in field
        move.w  i_plc(a0),(a1)
        rts
*
; set index sort level parameters
cod_SISL xsub
        regsave regs
        lea     sisl(pc),a0
        bra     doit
sisl    mulu    #i.slen,d1      ; get offset in list
        lea     i_sort-i.slen(a2,d1.w),a0
        move.l  p.cmp(a5),a1    ; place for level
        move.w  (a1),i_cmp(a0)
        move.l  p.fld(a5),a1    ; place for field
        move.b  1(a1),i_fld(a0)
        move.l  p.plc(a5),a1    ; place for place in field
        move.w  (a1),i_plc(a0)
        rts
*
; get index filter level parameters
cod_GIFL xsub
        regsave regs
        lea     gifl(pc),a0
        bra.s   doit
gifl    mulu    #i.flen,d1      ; get offset in list
        add.w   #i_filt,d1
        lea     -i.flen(a2,d1.w),a0
        move.l  p.cmp(a5),a1    ; place for level
        move.w  i_fcmp(a0),(a1)
        move.l  p.fld(a5),a1    ; place for field
        clr.b   (a1)
        move.b  i_ffld(a0),1(a1)
        move.l  p.plc(a5),a1    ; place for place in field
        move.w  i_fplc(a0),(a1)
        move.l  p.val(a5),a1    ; place for value
        move.l  i_fval(a0),(a1)
        move.l  i_fval+4(a0),4(a1)
        rts
*
; set index filter level parameters
cod_SIFL xsub
        regsave regs
        lea     sifl(pc),a0
        bra.s   doit
sifl    mulu    #i.flen,d1      ; get offset in list
        add.w   #i_filt,d1
        lea     -i.flen(a2,d1.w),a0
        move.l  p.cmp(a5),a1    ; place for level
        move.w  (a1),i_fcmp(a0)
        move.l  p.fld(a5),a1    ; place for field
        move.b  1(a1),i_ffld(a0)
        move.l  p.plc(a5),a1    ; place for place in field
        move.w  (a1),i_fplc(a0)
        move.l  p.val(a5),a1    ; place for value
        move.l  (a1),i_fval(a0)
        move.l  4(a1),i_fval+4(a0)
        rts

;
doit    move.l  a1,a5           ; keep params in a safe place
        moveq   #err.orng,d0    ; assume out of range
        move.w  p.lvl+2(a5),d1  ; sort level
        ble.s   codend          ; has to be >=1
        cmpi.w  #10,d1
        bgt.s   codend          ; and <=10
        moveq   #0,d0           ; clear error

        move.l  p.id(a5),d0     ; buffer id if passed
        move.l  d0,a2           ; or it can be the indexid
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   tindex          ; if not -> try it as an index
        move.l  b_dindex(a4),a2 ; take default index
tindex  move.l  a2,d0
        beq.s   codend          ; no index -> nothing to do
        xjsr    testiid         ; see if it is valid
        bne.s   codend
        move.l  i_buffer(a2),a4 ; then this is the buffer id

        move.w  p.lvl+2(a5),d1  ; sort level
        jsr     (a0)            ; do action
codend  subend
;
        end
