; set/get/clear mark status
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; get the mark status
; parameters
p.id    equ     $4      ; buffer id (long word, optional)
p.ret   equ     $c      ; mark status (return byte)
; errors
; itnf  buffer id invalid
cod_GMRK xsub
        regsave a1/a4/a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff           ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff   move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.l  p.ret(a5),a1    ; place to fill in return value
        move.b  b_mark(a4),(a1) ; fillin
codend
        subend
*
; set the mark status
; will only be set on disk (if disk based) after implementing
; parameters
;p.id    equ     $4      ; buffer id (long word, optional)
p.mark  equ     $8      ; new mark status (ubyte)
; errors
; itnf  buffer id invalid
cod_SMRK xsub
        regsave a1/a4/a5        ; HAS TO BE SAME AS GMRK
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff_          ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff_  move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   codend          ; if not -> error

        move.b  p.mark+3(a5),b_mark(a4)
        move.b  #1,b_change(a4) ; something has changed to the record !!
        subend
*
; clear all mark statusses
; parameters
;p.id    equ     $4      ; buffer id (long word, optional)
; errors
; itnf  buffer id invalid
; isyn  internal file structure is corrupted (should not occur)
; file i/o error (should not occur)
cod_CMRK xsub
        regsave d1/d7/a0/a3-a5
        move.l  a1,a5           ; keep params in a safe place

        move.l  p.id(a5),d0     ; buffer id if passed
        tst.w   p.id-4(a5)      ; is the buffer id given ?
        bne.s   tbuff3          ; yes -> ..
        xjsr    getbuff         ; get default buffer
tbuff3  move.l  d0,a4           ; keep it
        xjsr    testbid         ; and test if it is valid
        bne.s   cend            ; if not -> error

        move.l  b_file(a4),a3
        mutex

        ; now release clear all mark statusses
        ; run through the records
        ; we do this by running through all areas
        ; recordlinkage with recordid <>-1 is used
        move.l  f_area(a3),d1   ; place in list of areas
        beq.s   ahum            ; no records to release -> ..
arealp  move.l  d1,a5
        moveq   #99,d7          ; nr of linkages to run through
        lea     4(a5),a4        ; first record linkage
nxtrl   cmpi.l  #-1,rl_id(a4)   ; linkage used ??
        beq.s   endrl

        ; clear mark status for this one
        tst.b   f_file(a3)      ; file based
        bne.s   disk            ; yes -> ..
        move.l  rl_pos(a4),a0
        clr.b   r_mark(a0)
        bra.s   endrl
disk    ; clear mark status on disk
        move.l  f_chid(a3),a0
        move.l  rl_pos(a4),d1
        xjsr    iof_posa        ; position file pointer
        bne.s   ahum
        xjsr    iob_fbyt        ; get a byte
        bne.s   ahum
        moveq   #err.isyn,d0
        cmpi.b  #'R',d1
        bne.s   ahum
        moveq   #0,d1           ; new mark status
        xjsr    iob_sbyt        ; send it

endrl   adda.w  #rl.len,a4      ; start of next linkage
        dbf     d7,nxtrl

        move.l  (a5),d1         ; next area ??
        bne     arealp          ; if there is one

ahum    endmutex
        tst.b   f_file(a3)      ; file based ??
        beq.s   cend            ; no -> don't flush
        move.l  d0,d7
        move.l  f_chid(a3),a0
        xjsr    iof_flsh
        move.l  d7,d0
cend    subend
;
        end
