; This routine finds the THING vector    1989  Tony Tebby   QJUMP

        section thing

        xdef    thg_fthg

        include 'dev8_sys'
        include 'dev8_thg'
        include 'dev8_err'
        include 'dev8_qdos_sms'

thg_name dc.w   5,'THING'

;+++
; Find THING vector ('THG%',-1,THING trap emulation, EXECUTE THING)
;
;       a3  r   pointer to THING vector
;
;       error return 0 or ERR.FDNF
;---
thg_fthg
thgf.reg reg    d1/d2/a0/a2
        movem.l thgf.reg,-(sp)
        move.w  sr,d0                    ; all in supervisor mode please
        trap    #0
        move.w  d0,-(sp)

        moveq   #sms.info,d0             ; do get info
        trap    #do.sms2

        move.l  sys_thgl(a0),d0          ; pointer to thing list
        beq.s   thgf_nf                  ; ... none
thgf_look
        move.l  d0,a0
        move.l  (a0),d0                  ; last thing?
        bne.s   thgf_look

        lea     th_name(a0),a3  
        tst.b   (a3)+
        bne.s   thgf_nf                  ; rather a long name
        lea     thg_name+1,a2
        moveq   #0,d0
        move.b  (a2),d0                  ; name length (byte)
thgf_check
        cmpm.b  (a2)+,(a3)+              ; compare name
        dbne    d0,thgf_check
        bne.s   thgf_nf

        move.l  th_thing(a0),a3          ; point to thing
        cmp.l   #thh.flag,thh_flag(a3)   ; check it just in case
        bne.s   thgf_nf
        moveq   #-1,d0
        sub.l   thh_type(a3),d0          ; and type -1
        beq.s   thgf_exit

thgf_nf
        moveq   #err.fdnf,d0
thgf_exit
        move.w  (sp)+,sr
        movem.l (sp)+,thgf.reg
        tst.l   d0
        rts
*
        end
