; routine om een bepaalde extension thing aan te roepen
; speciale versie voor DATAdesign
; (c) 1991-93 by Joachim Van der Auwera for PROGS
        section text
        include dev8_sys
        include dev8_thg
        include dev8_err
        include dev8_qdos_sms
thg_name dc.w   17,'DATAdesign.engine'
thg_nam  dc.w   5,'THING'
regs    reg     a0-a5/d1-d7
;+++
; Find THING vector ('THG%',-1,THING trap emulation, EXECUTE THING)
;
;       a3  r   pointer to THING vector
;
;       error return 0 or ERR.FDNF
;---
thg_fthg
thgf.reg reg    d1/d2/a0/a2
        movem.l thgf.reg,-(sp)
        move.w  sr,d0                    ; all in supervisor mode please
        trap    #0
        move.w  d0,-(sp)

        moveq   #sms.info,d0             ; do get info
        trap    #do.sms2

        move.l  sys_thgl(a0),d0          ; pointer to thing list
        beq.s   thgf_nf                  ; ... none
thgf_look
        move.l  d0,a0
        move.l  (a0),d0                  ; last thing?
        bne.s   thgf_look

        lea     th_name(a0),a3  
        tst.b   (a3)+
        bne.s   thgf_nf                  ; rather a long name
        lea     thg_nam+1,a2
        moveq   #0,d0
        move.b  (a2),d0                  ; name length (byte)
thgf_check
        cmpm.b  (a2)+,(a3)+              ; compare name
        dbne    d0,thgf_check
        bne.s   thgf_nf

        move.l  th_thing(a0),a3          ; point to thing
        cmp.l   #thh.flag,thh_flag(a3)   ; check it just in case
        bne.s   thgf_nf
        moveq   #-1,d0
        sub.l   thh_type(a3),d0          ; and type -1
        beq.s   thgf_exit

thgf_nf
        moveq   #err.fdnf,d0
thgf_exit
        move.w  (sp)+,sr
        movem.l (sp)+,thgf.reg
        tst.l   d0
        rts
*
        xdef    _dde_free
_dde_free
        movem.l regs,-(sp)
        bsr     thg_fthg
        move.l  8(a3),a3        ;th_use
        moveq   #sms.fthg,d0
        moveq   #-1,d1
        lea     thg_name(pc),a0
        jsr     (a3)
        movem.l (sp)+,regs
        rts

; CTHG_
; registers
; d0 |                                  | error
; d1 | extension name                   | preserved
; a1 | parameters                       | preserved
; a3 | thing                            | preserved
; adjusted to be called in C68, parameters : thingaddr, ext-name, paramlist
; by Joachim and Nathan Van der Auwera in December 1992 for DATAdesign
;
keep    reg     d1/a1/a3
thh_next equ    $08     offset of next thing in list
thh_exid equ    $0c     extra ID
thh_code equ    $18     entry point of extension code
p.th    equ     16
p.ext   equ     20
p.par   equ     24
        xdef    _cthg_
_cthg_   movem.l keep,-(sp)
        move.l  p.th(sp),a3
        move.l  p.ext(sp),d1
        move.l  p.par(sp),a1
next    cmp.l   thh_exid(a3),d1         ; is this the extension we need ?
        beq.s   found                   ; yes -> ..
        tst.l   thh_next(a3)            ; is there another one ?
        beq.s   exit                    ; no -> ..
        add.l   thh_next(a3),a3         ; ptr to next thing in list
        bra.s   next                    ; take next
found
        lea     thh_code(a3),a3         ; ptr to code
        jsr     (a3)                    ; call extension thing
        movem.l (sp)+,keep
        tst.l   d0                      ; test error
        rts                             ; return

exit    movem.l (sp)+,keep
        moveq   #-7,d0                  ; item not found
        rts

; routine to be called from C68, to get the thing addres
;  --> necessary to use the previous command
; (c) August 1992 By Joachim Van der Auwera, for PROGS
; get thingaddr
        xdef    _getdde_
_getdde_
        movem.l regs,-(sp)
        jsr     thg_fthg(pc)    ;find thing thing
        move.l  8(a3),a3        ;TH_ENTRY
        lea     thg_name(pc),a0 ;name of thing to use
        moveq   #-1,d1          ;myself
        moveq   #0,d2           ; extension name
        moveq   #sms.uthg,d0    ;Use Thing
        jsr     (a3)
        bmi.s   eget
        move.l  a1,d0
eget    movem.l (sp)+,regs
        tst.l   d0
        rts
;
        end
