; aid routines for record retrieving, etc..
; written for DATAdesign engine v2.+
; (c)1992 by Joachim Van der Auwera for PROGS
        section text
        include aid_mac
        include struct_h
        include dev8_err
*
; find a record linkage with given recordid
; returns address of linkage
; should be called in supervisor for safety
; parameters :  d1      recordid
;               a3      fileid
; return        d0      error code
;               a1      address of record linkage in tree
; errors
; itnf  record not found in this file
findrec xsub
        regsave d2
        moveq   #0,d0           ; assume no problem

        move.l  f_top(a3),d2    ; start of file
        beq.s   itnf            ; oops, not found
floop   move.l  d2,a1           ; start of record linkage
        cmp.l   rl_id(a1),d1    ; is this the one ?
        beq.s   findend         ; -> found
        bcc.s   fright          ; take right node
        ; left node
        move.l  rl_left(a1),d2  ; next one (smaller id)
        bne.s   floop           ; if it exists
        bra.s   itnf            ; or we won't be able to find it
fright  ; right node
        move.l  rl_right(a1),d2 ; next one (larger id)
        bne.s   floop           ; if it exists

itnf    moveq   #err.itnf,d0    ; no we couldn't find it
findend
        subend
;
        end
