/* This file is part of DATAdesign
 * written by Joachim Van der Auwera
 * (c) 2-5 December 1992 for PROGS, PROfessional & Graphical Software
 * amended by Wolfgang Lenerz November 2000 for inclusion of IndexFindString
 *
 * routines to call the DATAdesign engine
 */

#include "DATAdesign.h"

long	DATAdesign =0L;

/* some prototypes */
long	getdde_();
void	dde_free();
long	cthg_(long thing, long extension, long *params);

/* initialise DATAdesign.engine thing and get address */
long DDinit()
		{
		DATAdesign = getdde_();
		if (DATAdesign<0) { return DATAdesign; }
				else return 0;
		}

/* free DATAdesign.engine thing */
void DDfree()
		{
		dde_free();
		DATAdesign=0;
		}

#define NEWF	0x4e455746
long DDnewfile(char *c)
		{
		long p[4];
		long r;
		p[0]=0x02000000+strlen(c);		/* substring */
		p[1]=c;
		p[2]=0xa0200000;		/* return long */
		p[3]=&r;

		return cthg_(DATAdesign, NEWF, p);
		}

long DDbid_(long b, long c)
		{
		long p[2];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */

		return cthg_(DATAdesign, c, p);
		}

long DDint_(long b, long i, long c)
		{
		long p[3];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=i;

		return cthg_(DATAdesign, c, p);
		}

long DDseti_(long b, short f, long l, long v, long e)
		{
		long p[5];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)f;
		p[3]=v;
		p[4]=l;

		return cthg_(DATAdesign, e, p);
		}

long DDret_(long b, long *r, long c)
		{
		long p[4];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=0xa0200000;		/* return long */
		p[3]=r;

		return cthg_(DATAdesign, c, p);
		}

long DDi_ret_(long b, long i, long *r, long c)
		{
		long p[5];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=i;
		p[3]=0xa0200000;		/* return long */
		p[4]=r;

		return cthg_(DATAdesign, c, p);
		}

long DDi2_ret_(long b, short f, long i, long *r, long c)
		{
		long p[6];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)f;
		p[3]=i;
		p[4]=0xa0200000;		/* return long */
		p[5]=r;

		return cthg_(DATAdesign, c, p);
		}

long DDretstr_(long b, char *r, long c)
		{
		long p[4];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=0xa2000010;		/* return substring, max 16 chars */
		p[3]=r;

		return cthg_(DATAdesign, c, p);
		}

long DDint3_(long b, short f, long l, long n, long c)
		{
		long p[5];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)f;
		p[3]=l;
		p[4]=n;

		return cthg_(DATAdesign, c, p);
		}

long DDxsavx_(long b, char *n, char *d, short o, long e)
		{
		long p[7];
		long r;
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		if (n) {
				p[2]=0x02000000+strlen(n);		/* substring */
				p[3]=(long) n;
				} else	p[2]=0;
		if (d) {
				p[4]=0x02000000+strlen(d);		/* substring */
				p[5]=(long) d;
				} else	p[4]=0;
		p[6]=(long)o;

		return cthg_(DATAdesign, e, p);
		}

long DDxifl_(long b, short l, short *c, short *f, short *pl, char *v, long e)
		{
		long p[11];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)l;
		p[4]=c; 			/* compare */	/* always updated so we don't */
		p[6]=f; 			/* field */ /* need to fill in p[3],p[5], */
		p[8]=pl;				/* place */ /* p[7] and p[9]			  */
		p[10]=v;				/* value */

		return cthg_(DATAdesign, e, p);
		}

long DDxisl_(long b, short l, short *c, short *f, short *pl, long e)
		{
		long p[9];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)l;
		p[4]=c; 			/* compare */	/* always updated so we don't */
		p[6]=f; 			/* field */ /* need to fill in p[3],p[5]	*/
		p[8]=pl;				/* place */ /* and p[7] 			  */

		return cthg_(DATAdesign, e, p);
		}

#define ADDF	0x41444446
long DDaddfield(long b, char *c, short t)
		{
		long p[5];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=0x02000000+strlen(c);		/* substring */
		p[3]=c;
		p[4]=(long)t;

		return cthg_(DATAdesign, ADDF, p);
		}

#define IDFI	0x49444649
long DDfieldid(long b, char *c, short *r)
		{
		long p[6];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=0x02000000+strlen(c);		/* substring */
		p[3]=c;
		p[4]=0xa0100000;		/* return short */
		p[5]=r;

		return cthg_(DATAdesign, IDFI, p);
		}

#define FLDN	0x464c444e
long DDfieldname(long b, short f, char *r)
		{
		long p[5];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long) f;
		p[3]=0xa2000010;		/* return substring, max 16 chars */
		p[4]=r;

		return cthg_(DATAdesign, FLDN, p);
		}

#define CYCL	0x4359434c
long DDcyclefile(long *i, char *r)
		{
		long p[4];
		p[0]=0xa0200000;		/* return long */
		p[1]=i;
		p[2]=0xa2000020;		/* return substring, max 32 chars */
		p[3]=r;

		return cthg_(DATAdesign, CYCL, p);
		}

#define CYCF	0x43594346
long DDcyclefield(long b, short *i, short *t, char *r)
		{
		long p[8];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=0xa0100000;		/* return short */
		p[3]=i;
		p[4]=0xa0100000;		/* return short */
		p[5]=t;
		if (!t) p[4]=0; 	/* oops, don't update fieldtype */
		p[6]=0xa2000010;		/* return substring, max 16 chars */
		p[7]=r;

		return cthg_(DATAdesign, CYCF, p);
		}

#define FLDC	0x464c4443
long DDfieldclear(long b, short f, short s)
		{
		long p[4];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long) f;
		p[3]=(long) s;

		return cthg_(DATAdesign, FLDC, p);
		}

#define FLDR	0x464c4452
long DDfieldrename(long b, short f, char *n)
		{
		long p[5];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long) f;
		p[3]=0x02000000+strlen(n);		/* substring */
		p[4]=(long) n;

		return cthg_(DATAdesign, FLDC, p);
		}

#define GFLD	0x47464c44
long DDgetfield(long b, short f, long l, char *pl, long *r)
		{
		long p[8];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long) f;
		p[3]=l;
		p[4]=0x80000000;		/* ptr to buffer */
		p[5]=pl;
		p[6]=0xa0200000;		/* return long */
		p[7]=r;

		return cthg_(DATAdesign, GFLD, p);
		}

#define SFLD	0x53464c44
long DDsetfield(long b, short f, long l, char *pl)
		{
		long p[6];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long) f;
		p[3]=l;
		p[4]=0x80000000;		/* ptr to buffer */
		p[5]=pl;

		return cthg_(DATAdesign, SFLD, p);
		}

#define IDBF	0x49444246
long DDbufferid(long *r)
		{
		long p[2];
		p[0]=0xa2000000;		/* long return */
		p[1]=r;

		return cthg_(DATAdesign, IDBF, p);
		}

#define ILOA	0x494c4f41
long DDindexload(long b, char *n, char *d)
		{
		long p[8];
		long r;
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		if (n) {
				p[2]=0x02000000+strlen(n);		/* substring */
				p[3]=(long) n;
				} else	p[2]=0;
		if (d) {
				p[4]=0x02000000+strlen(d);		/* substring */
				p[5]=(long) d;
				} else	p[4]=0;
		p[6]=0xa0200000;		/* return long */
		p[7]=&r;

		return cthg_(DATAdesign, ILOA, p);
		}

#define USE 0x55534520
long DDusefile(long b, char *n, char *d, short a)
		{
		long p[9];
		long r;
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		if (n) {
				p[2]=0x02000000+strlen(n);		/* substring */
				p[3]=(long) n;
				} else	p[2]=0;
		if (d) {
				p[4]=0x02000000+strlen(d);		/* substring */
				p[5]=(long) d;
				} else	p[4]=0;
		p[6]=(long)a;
		p[7]=0xa0200000;		/* return long */
		p[8]=&r;

		return cthg_(DATAdesign, USE, p);
		}

#define SFST	0x53465354
long DDsetfilestatus(long b, short s, char *n, char *d)
		{
		long p[7];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)s;
		if (n) {
				p[3]=0x02000000+strlen(n);		/* substring */
				p[4]=(long) n;
				} else	p[3]=0;
		if (d) {
				p[5]=0x02000000+strlen(d);		/* substring */
				p[6]=(long) d;
				} else	p[5]=0;

		return cthg_(DATAdesign, SFST, p);
		}

#define SDBL	0x5344424c
long DDsetdouble(long b, short f, long l, double v)
		{
		long p[6];
		double *q;
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)f;
		p[5]=l;
		q=(double *)&p[3];
		*q=v;

		return cthg_(DATAdesign, SDBL, p);
		}

#define SSTR	0x53535452
long DDsetline(long b, short f, long l, char *v)
		{
		long p[6];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)f;
		p[5]=l;
		p[3]=0x02000000+strlen(v);		/* substring */
		p[4]=v;

		return cthg_(DATAdesign, SSTR, p);
		}

#define GSTR	0x47535452
long DDgetline(long b, short f, long i, char *r, short space)
		{
		long p[6];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)f;
		p[3]=i;
		p[4]=0xa2000000+space;	/* return substring, maxlen space */
		p[5]=r;

		return cthg_(DATAdesign, GSTR, p);
		}

#define LENS	0x4c454e53
long DDlinelen(long b, short f, long l, long *r)
		{
		long p[6];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)f;
		p[3]=l;
		p[4]=0xa0200000;		/* return long */
		p[5]=r;

		return cthg_(DATAdesign, LENS, p);
		}

#define FNDS	0x464e4453
long DDfindstring(long b, short f, short cmp, char *v, short *rf, short *pl)
		{
		long p[10];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)f;
		p[3]=(long)cmp;
		p[4]=0x02000000+strlen(v);		/* substring */
		p[5]=v;
		if (rf) {
				p[6]=0xa0100000;		/* update word */
				p[7]=rf;
				} else	p[6]=0;
		if (pl) {
				p[8]=0xa0100000;		/* update word */
				p[9]=pl;
				} else	p[8]=0;

		return cthg_(DATAdesign, FNDS, p);
		}

#define FNDD	0x464e4444
long DDfinddouble(long b, short f, short cmp, double v, short *rf, short *pl)
		{
		long p[10];
		double *q;
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)f;
		p[3]=(long)cmp;
		q=(double *)&p[4];
		*q=v;
		if (rf) {
				p[6]=0xa0100000;		/* update word */
				p[7]=rf;
				} else	p[6]=0;
		if (pl) {
				p[8]=0xa0100000;		/* update word */
				p[9]=pl;
				} else	p[8]=0;

		return cthg_(DATAdesign, FNDD, p);
		}

#define FNDI	0x464e4449
long DDfindinteger(long b, short f, short cmp, long v, short *rf, short *pl)
		{
		long p[10];
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		p[2]=(long)f;
		p[3]=(long)cmp;
		p[4]=v;
		p[5]=0;
		if (rf) {
				p[6]=0xa0100000;		/* update word */
				p[7]=rf;
				} else	p[6]=0;
		if (pl) {
				p[8]=0xa0100000;		/* update word */
				p[9]=pl;
				} else	p[8]=0;

		return cthg_(DATAdesign, FNDI, p);
		}

#define IFND	0x49464e44
long DDindexfind(long b, char *v, long *r)
		{
		long p[6];
		double *q;
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		q=(double *)&p[2];
		*q=*(double *)v;
		p[4]=0xa0200000;		/* return long */
		p[5]=r;

		return cthg_(DATAdesign, IFND, p);
		}
#define IFDS	0x49464453
long DDindexfindstring(long b, char *v, long *r)
		{
		long p[6];
		double *q;
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		q=(double *)&p[2];
		*q=*(double *)v;
		p[4]=0xa0200000;		/* return long */
		p[5]=r;

		return cthg_(DATAdesign, IFDS, p);
		}

		

#define SORT	0x534f5254
long DDsortfile(long b, short nr, ...)
		{
		va_list args;
		long p[34];
		long *q=&p[2];
		long r, i;

		va_start(args,nr);
		if (nr>10) nr=10;
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		for (i=0;i<nr;i++) {
				*q++=va_arg(args, long);		/* compare */
				*q++=va_arg(args, long);		/* field */
				*q++=va_arg(args, long);		/* place */
				}
		*q++=-1;
		p[32]=0xa0200000;
		p[33]=&r;
		va_end(args);

		return cthg_(DATAdesign, SORT, p);
		}

#define FILT	0x46494c54
long DDfilter(long b, short nr, ...)
		{
		va_list args;
		long p[54];
		long *q=&p[2];
		double *db1, *db2;
		long r, i;

		va_start(args,nr);
		if (nr>10) nr=10;
		p[0]=0x00200000;		/* long (anything really, but not 0 */
		p[1]=b;
		if (!b) p[0]=0; 	/* oops, no bufferid passed */
		for (i=0;i<nr;i++) {
				*q++=va_arg(args, long);		/* compare */
				*q++=va_arg(args, long);		/* field */
				*q++=va_arg(args, long);		/* place */
				db1=(double *)q;
				db2=va_arg(args, double *);
				q+=2;
				*db1=*db2;						  /* 8.b value to compare */
				}
		*q++=-1;
		p[52]=0xa0200000;
		p[53]=&r;
		va_end(args);

		return cthg_(DATAdesign, FILT, p);
		}
