; read/edit string routines, oorspronkelijk uit WMAN,
; aangepast voor gebruik in DATAdesign SuperBASIC interface
; - stopt ook be drukken van tab/shift tab/function keys
; - clear niet de volledige window, maar uitsluitend rechts v/d cursor
        section text
        include aid_mac
        include win1_inc_keys_k
        include win1_inc_qdos_io
        include win1_inc_keys_err
;
rname   xsub
        regsave d2-d7/a1-a4
        moveq   #0,d7
        bra.s   edit

ename   xsub
        regsave d2-d7/a1-a4
        moveq   #-1,d7

edit    move.l  a1,a4           ; keep address with buffer
        move.l  4(a1),-(sp)     ; keep so we can use it
        move.l  (a1),-(sp)
        moveq   #iow.chrq,d0    ; character coordinate query
        bsr     do_io
        bne.s   start
        move.l  a4,a1
        move.w  (a1),d2         ; line len
        moveq   #iow.pixq,d0
        bsr     do_io
        bne.s   start
        move.l  a4,a1
        moveq   #0,d1
        move.w  (a1),d1
        divu    d2,d1
        move.l  d1,d4
        moveq   #0,d6
        move.w  (a1),d6
        sub.w   4(a1),d6
        divu    d1,d6
        move.l  4(a1),d5

start   move.l  (sp)+,(a1)+     ; restore buffer
        move.l  (sp)+,(a1)
        tst.l   d0              ; error ??
        bne     codend
        moveq   #err.bffl,d0    ; assume buffer full
        cmp.w   (a4),d6
        bls     codend
        moveq   #iow.clrr,d0    ; clear right hand side of cursor line
        bsr     do_io1
        move.l  a4,a1
        move.w  (a1)+,d2        ; linelen
        moveq   #iob.smul,d0
        bsr     do_io1
        and.w   (a4),d7
        bne     loop
        bsr     spix
        bsr     getchar
        cmpi.b  #k.space,d2
        bne.s   cont
        moveq   #k.enter,d2

cont    cmpi.b  #k.space,d2
        bcs.s   decide
        cmpi.b  #k.maxch,d2
        bhi.s   decide
        moveq   #iow.clrr,d0
        bsr     do_io1
        clr.w   (a4)
        bra.s   decide

loop    bsr     getchar

decide
        cmpi.b  #k.bspce,d2
        beq     bspace
        cmpi.b  #k.enter,d2
        beq.s   done
        cmpi.b  #k.esc,d2
        beq.s   done
        cmpi.b  #k.tab,d2
        beq.s   done
        cmpi.b  #$fd,d2         ; shift tab
        beq.s   done
        cmpi.b  #k.space,d2
        bcs     loop
        cmpi.b  #k.maxch,d2
        bhi     cursork
        moveq   #-2,d0
        add.w   d6,d0
        cmp.w   (a4),d0
        bcs     loop
        move.w  (a4),d0
        lea     2(a4,d0.w),a1
        sub.w   d7,d0
        bra.s   doshiftr
shiftr  move.b  -(a1),1(a1)
doshiftr dbf    d0,shiftr
        move.b  d2,(a1)
        addq.w  #1,(a4)
        move.w  (a4),d2
        sub.w   d7,d2
        addq.w  #1,d7           ; right one char

send    moveq   #iob.smul,d0
do      bsr     do_io1
        bsr     spix
        bra     loop

done    move.w  (a4),d3
        moveq   #k.enter,d6
        move.b  d6,2(a4,d3.w)
        moveq   #0,d1
        move.b  d2,d1
        cmp.w   d6,d1
codend  subend

left    tst.w   d7              ; at start of line
        beq     loop
        subq.w  #1,d7           ; move one left
        bra.s   endloop

right   cmp.w   (a4),d7         ; at end of line
        beq     loop
        addq.w  #1,d7           ; move one right
        bra.s   endloop

begin   clr.w   d7

endloop bsr     spix
        bra     loop

delleft tst.w   d7
        beq     loop
        move.l  a4,a1
        move.w  (a1)+,d0
        move.l a1,a2
        adda.w  d7,a1
        sub.w   d7,d0
        move.w  d0,(a4)
        bra.s   docopy
copy    move.b  (a1)+,(a2)+
docopy  dbf     d0,copy
        clr.w   d7
        bsr     spix
        move.l  a4,a1
        move.w  (a1)+,d2
        moveq   #iob.smul,d0
        bsr     do_io1
        moveq   #iow.clrr,d0
        bra     do

setpos  move.w  (a4),d7
        bra.s   endloop

newlen  move.w  d7,(a4)
        moveq   #iow.clrr,d0
        bsr     do_io1
        bra     loop

clear   clr.w   (a4)
        clr.w   d7
        bsr     spix
        moveq   #iow.clrr,d0
        bsr     do_io
        bra     loop

delete  cmp.w   (a4),d7
        beq     loop
        addq.w  #1,d7

bspace  tst.w   d7
        beq     loop
        move.w  (a4),d0
        subq.w  #1,d7
        lea     2(a4,d7.w),a1
        sub.w   d7,d0
        movem.l d0/a1,-(sp)
        bra.s   doshiftl
shiftl  move.b  1(a1),(a1)+
doshiftl dbf    d0,shiftl
        movem.l (sp)+,d2/a1
        move.b  #k.space,-1(a1,d2.w)
        subq.w  #1,(a4)
        bsr.s   spix
        bra     send

spix    move.w  d2,d3
        move.w  d7,d1
        mulu    d4,d1
        swap    d5
        add.w   d5,d1
        swap    d5
        move.w  d5,d2
        moveq   #iow.spix,d0
        bsr     do_io2
        move.w  d3,d2
        rts

cursork
        move.b  d2,d1
        subi.b  #k.curs,d1      ; test for cursor codes
        beq     left
        subq.w  #1,d1
        beq     begin
        subq.b  #1,d1
        beq.s   bspace
        subq.b  #1,d1
        beq     delleft
        subq.b  #3,d1
        beq     delleft
        subq.b  #2,d1
        beq     right
        subq.b  #1,d1
        beq     setpos
        subq.b  #1,d1
        beq.s   delete
        subq.b  #1,d1
        beq     newlen
        subq.b  #3,d1
        beq     newlen
        subq.b  #2,d1
        beq     done
        subq.b  #3,d1
        beq     clear
        subq.b  #5,d1
        beq     done
        bmi     loop            ; not function key -> read next
        sub.b   #$24,d1
        bmi     done            ; function key -> return
        bne     loop
        bsr.s   getchar         ; get 2 chars to form hex ascii code
        bsr     number
        bmi     loop
        move.b  d2,d3
        lsl.b   #4,d3
        bsr.s   getchar
        bsr.s   number
        bmi     loop
        or.w    d2,d3
        move.b  d3,d2
        bra     decide

number
        subi.b  #'0',d2
        bcs.s   neg
        cmpi.b  #9,d2
        bls.s   test
        subq.b  #7,d2
        bcs.s   neg
        bclr    #5,d2
        cmpi.b  #15,d2
        bls.s   test

neg     moveq   #-1,d2
test    tst.b   d2
        rts

getchar
        moveq   #iow.ecur,d0
        bsr.s   do_io2
        moveq   #iob.fbyt,d0
        bsr.s   do_io2
        move.b  d1,d2           ; keep byte
        moveq   #iow.dcur,d0
        bsr.s   do_io2
        rts

do_io2  bsr     do_io
        beq.s   do_rts
        addq.l  #8,sp
        bra     codend

do_io1  bsr     do_io
        beq.s   do_rts
        addq.l  #4,sp
        bra     codend

do_io   move.l  d3,-(sp)
        moveq   #forever,d3
        trap    #do.io
        move.l  (sp)+,d3
        tst.l   d0
do_rts  rts
;
        end
